package zb2smt;
/**
 * @author valeriojr, eberton, Alessandro Gurgel 
 * 
 * 
 * Preferences - Java - Code Style - Code Templates
 */
import java.util.LinkedList;
import java.io.*;
import java.net.URL;


import zb2smt.bol.*;

public class POPrintVerit implements IPOPrint {
	
	boolean assumptions_found;
	boolean printingAssumpions = false;
	int count_var = 0;
	POLabel pOLabel;
	LinkedList<BIdentifier> listVariablesQuantified;
	LinkedList <Integer> listSizeSetsUseds ;
	
	
	public String getExtension() {
		return "smt";
	}
	
	public static byte[] convert(byte[] data, String srcEncoding, String targetEncoding) {
		
		byte[] result  = null;
		  // First, decode the data using the source encoding.
		  // The String constructor does this (Javadoc).
		try{
			String str = new String(data, srcEncoding);
		
			// Next, encode the data using the target encoding.
			// The String.getBytes() method does this.
			result = str.getBytes(targetEncoding);
					  
		}catch(UnsupportedEncodingException e){
			e.printStackTrace();
		}
		
		  return result;
	  }
	
	
	/**
	 * Metodo que guarda a impressao do arquivo SMT correspondente
	 * do predicado guardado em pOList, 
	 * @param pOList
	 * @param sb StringBuffer que guardara impressao do arquivo
	 * @param indent Identacao
	 */
	public void toPrintInBuffer (LinkedList<POLabel> pOList, StringBuffer sb,
			String indent, String archiveName){
		int count=0;
		StringBuffer header = new StringBuffer();
		StringBuffer body = new StringBuffer();

		// Create a list proof names
		String [] proofnames = new String[pOList.size()];
		for(int s=0 ;s<proofnames.length ; s++ )
			proofnames[s]=((POLabel)pOList.get(s)).getLabel();

		while (!pOList.isEmpty()) {
			assumptions_found = false;

			pOLabel = ((POLabel) (pOList.getFirst()));
			pOList.removeFirst();

			// Initialization	
			sb.delete(0, sb.length()); 
			header.delete(0, header.length());
			body.delete(0, body.length());
			listVariablesQuantified = new LinkedList<BIdentifier>();
			listSizeSetsUseds = new LinkedList<Integer> ();


			// print partialy the header
			header.append(";;Proof Obligations of Module in Harvey/SMT Language\n");
			header.append("(benchmark "+archiveName+proofnames[count]+count+
					"\n :logic UNKNOWN\n" +
			" :extrasorts (Int boolean)\n");




			if (pOLabel.getLabel().equals("Constraints")) {
				body.append(";;CONSTRAINTS\n :formula (not \n\t");

			}else if (pOLabel.getLabel().equals("Properties")) {
				body.append(";;PROPERTIES\n :formula (not \n\t");


			}else if (pOLabel.getLabel().equals("Invariant")) {
				body.append(";;INVARIANT\n :formula (not \n\t");

			}else if (pOLabel.getLabel().equals("Initialization")) {
				body.append(";;INITIALIZATION\n :formula (not \n\t");


			} else if (pOLabel.getLabel().equals("Assertion")) {
				body.append(";;ASSERTION"+count+"\n :formula (not \n\t");


			} else if (pOLabel.getLabel().equals("Operation")) {
				body.append(";;OPERATIONS\n :formula (not \n\t");


			}else{
				body.append(";;UNKOWN-"+pOLabel.getLabel());
				body.append("\n :formula (not \n\t");

			}
			pOLabel.getPOPredicate().acceptPrint(this, body, indent);
			body.append("\t\n)\n)");


			// Print the continuation of header 
			// add extras
			printExtras(header);
			// This line add  theories of Format SMT harvey 
			String strPrintFormat = creatTheories(); 
			header.append(strPrintFormat);
			// add assumptions
			printAssumptions(header);
			// append all proof obligation ( header + body )
			sb.append(header.toString()+body.toString());
		}
	}
	
	
	
	public void toPOPrintFormat(LinkedList pOList, StringBuffer sb,
			String indent, String destpath, String archiveName) {
		
		
		int count=0;
		StringBuffer header = new StringBuffer();
		StringBuffer body = new StringBuffer();
		
		// Take the file name without extension
		{
			String aux[] = archiveName.split(".xml");
			archiveName = aux[0];			
		}
		
		// Create a list proof names
		String [] proofnames = new String[pOList.size()];
		for(int s=0 ;s<proofnames.length ; s++ )
			proofnames[s]=((POLabel)pOList.get(s)).getLabel();
		
		
		
		 

			
		while (!pOList.isEmpty()) {
			assumptions_found = false;
			
			pOLabel = ((POLabel) (pOList.getFirst()));
			pOList.removeFirst();
			
		    // Initialization	
			sb.delete(0, sb.length()); 
			header.delete(0, header.length());
			body.delete(0, body.length());
			listVariablesQuantified = new LinkedList<BIdentifier>();
			listSizeSetsUseds = new LinkedList<Integer> ();
			
			
			// print partialy the header
			header.append(";;Proof Obligations of Module in Harvey/SMT Language\n");
			header.append("(benchmark "+archiveName+proofnames[count]+count+
					  "\n :logic UNKNOWN\n" +
					    " :extrasorts (Int)\n");
			

			
			
			if (pOLabel.getLabel().equals("Constraints")) {
				body.append(";;CONSTRAINTS\n :formula (not \n\t");
				
			}else if (pOLabel.getLabel().equals("Properties")) {
				body.append(";;PROPERTIES\n :formula (not \n\t");

				
			}else if (pOLabel.getLabel().equals("Invariant")) {
				body.append(";;INVARIANT\n :formula (not \n\t");
				
			}else if (pOLabel.getLabel().equals("Initialization")) {
				body.append(";;INITIALIZATION\n :formula (not \n\t");

				
			} else if (pOLabel.getLabel().equals("Assertion")) {
				body.append(";;ASSERTION"+count+"\n :formula (not \n\t");
				
				
			} else if (pOLabel.getLabel().equals("Operation")) {
				body.append(";;OPERATIONS\n :formula (not \n\t");
				
				
			}else{
				body.append(";;UNKOWN-"+pOLabel.getLabel());
				body.append("\n :formula (not \n\t");

			}
		
			pOLabel.getPOPredicate().acceptPrint(this, body, indent);
			body.append("\t\n)\n)");
			
			
			// Print the continuation of header 
			// add extras
			printExtras(header);
			// This line add  theories of Format SMT harvey 
			String strPrintFormat = creatTheories(); 
			header.append(strPrintFormat);
			// add assumptions
			printAssumptions(header);
			
			
			// append all proof obligation ( header + body )
			sb.append(header.toString()+body.toString());
			
			// Write in file
			FileWriter fichierFile;
			try {
				String filename = destpath + File.separator +archiveName+proofnames[count]+count+".smt";
			
				fichierFile = new FileWriter(filename);
			
				fichierFile.write(""+sb.toString()); fichierFile.close();
				
			} catch (IOException e) {
				e.printStackTrace();
			}
			count++;
			
		}
		

		//Creating the prover script
		StringBuffer cmdterm = new StringBuffer(); 
		 count=0;
		


		for(int g=0; g < proofnames.length ; g++){
			
			
			cmdterm.append("rv "+archiveName+proofnames[g]+g+".smt\n");

		}
		try{
			
			String filename = destpath + File.separator +archiveName+".sh";
			FileWriter fichierFile = new FileWriter(filename);
			fichierFile.write(""+cmdterm);
		    fichierFile.close();

		    if(System.getProperty("os.name").toUpperCase().indexOf("WINDOWS") >= 0){
		    	
		    }else
		    if(System.getProperty("os.name").toUpperCase().indexOf("LINUX") >= 0){
		    	SystemTermCommand.callHarvey("chmod +x "+filename);
		    }else{
		    	throw new IOException();
		    }
		    // Call the  script of prove

		    System.out.println(filename);
		    
		}
		catch(Exception e){
			
			System.err.println("Erro - The Batcave can't write file");
		}
		
		
		
		sb.delete(0, sb.length());
		
		sb.append(";;The files of proof-obligations are:\n");
		
		for(int i=0; i< proofnames.length;i++)
			sb.append(" ;;"+proofnames[i]+i+".smt\n");
		sb.append("\n;; If you want to prove it then execute the \""+archiveName+".sh\"");
		
		
		// FIM da Integracao da chamada harvey
		/***	END VALERIO		***/
		
	}
	
	private String creatTheories(){
		
//	 Add the theorys in proof.
		
		URL uri = POPrintVerit.class.getResource("smt_theory_harvey.txt");
		String  strPrintFormat=null;
		
		try {
			Reader stream = null;
			int cont = 0;
			stream = new InputStreamReader(uri.openStream());
			char[] charbuff = new char[10000];
			while(stream.ready()){
				stream.read(charbuff, cont, 1);
				cont++;
			}
			char[] charbuff_ = new char[cont];
//			TODO modificacao, para funcionar no Windows.
			/* No windows, eh colocado o caractere /r que nao e atualmente reconhecido () pelo harvey*/
			for(int i=0;i<cont;i++){
				if((int)charbuff[i] != 13){
					charbuff_[i] = charbuff[i];
				}
				else{
					charbuff_[i] = ' ';
				}
				//charbuff_[i] = charbuff[i];
			}
			
			strPrintFormat = new String( new String(charbuff_) + simpleSetTheories()+ "                \n\n");
			
			
		  } catch (Exception e) {
			  System.err.println("\n\n\n\n");
				System.err.println("Can't open smt_theory_harvey.smt");
				System.err.println("\n\n\n\n");
				e.printStackTrace();
		  }
		  
		  
		  return strPrintFormat;
		
	}
	private String simpleSetTheories(){
		int length = listSizeSetsUseds.size();
		
		StringBuffer tmp = new StringBuffer();

		for(int i=0 ; i < length ; i++){

			tmp.append("                (set"+listSizeSetsUseds.get(i)+" (lambda ");
			
				for(int j=0;j<listSizeSetsUseds.get(i);j++){
					tmp.append("(?e"+j+" Int) ");
				}
			tmp.append(".\n                (lambda (?y Int) . (or ");
				for(int j=0;j<listSizeSetsUseds.get(i);j++){
					tmp.append("(= ?y ?e"+j+") ");
				}
			
			tmp.append("))))\n");
		}

		return tmp.toString();
	}
	

	/* Ainda Fora de ordem*/
	
	public void printFormat(Results results, StringBuffer sb,
			String indent){
		
		for (int i = 0; i < results.getIdentifiers().length; i++) {
			results.getIdentifiers()[i].acceptPrint(this, sb, indent);
			if (i != results.getIdentifiers().length - 1)
				sb = sb.append(",");
		}
		
	}
	
	
	/* Ainda Fora de ordem*/
	
	public void printFormat(SetDeclaration setDeclaration, StringBuffer sb,
			String indent) {

		setDeclaration.getIdentifier().acceptPrint(this, sb, indent);
		if (setDeclaration.getValues() != null) {
			sb = sb.append("= {");
			for (int i = 0; i < setDeclaration.getValues().length; i++) {
				setDeclaration.getValue(i).acceptPrint(this, sb, indent);
				if (i != setDeclaration.getValues().length - 1)
					sb = sb.append(",");
			}
			sb = sb.append("}\n");
		}
	}

	public void printFormat(Or or, StringBuffer sb, String indent) {
		sb.append("(or ");
		for (int i = 0; i < or.getPredicates().length; i++) {
			or.getPredicate(i).acceptPrint(this, sb, indent);
			if (i != or.getPredicates().length - 1)
				sb = sb.append(" ");
		}
		sb.append(")");
	}

	public void printFormat(And and, StringBuffer sb, String indent) {

		if (assumptions_found == false ){
			
		int size = pOLabel.getAssumptions().size();
		LinkedList<Predicate> tmp = new LinkedList<Predicate>();
		
			for(int i=0; i<and.getPredicates().length; i++){
				for (int j=0; j<size;j++){
					if ( pOLabel.getAssumptions().get(j) ==  and.getPredicates()[i]){
						assumptions_found = true;
						i++;
						if(i==and.getPredicates().length)
							break;
					}else {
						tmp.add(and.getPredicates()[i]);
					}
				}
			}
			
			
			if (assumptions_found){
				int sizetmp = tmp.size(); 
				if(sizetmp>1){
					sb.append("(and ");
					for (int i = 0; i < sizetmp; i++) {
						sb = sb.append(indent);
						tmp.get(i).acceptPrint(this, sb, indent);
						if (i != and.getPredicates().length - 1)
							sb = sb.append(" ");
					}
					sb = sb.append(")");					
					
				}else if(sizetmp == 1 ){
						//sb.append("(");
						sb = sb.append(indent);
						tmp.get(0).acceptPrint(this, sb, indent);
						//sb = sb.append(")");					
					
				}else {
					
					sb.append(" true ");
				}
				return;
			}
		
		
		}
		/* else print the predicates */
			sb.append("(and ");
			for (int i = 0; i < and.getPredicates().length; i++) {
				sb = sb.append(indent);
				and.getPredicate(i).acceptPrint(this, sb, indent);
				if (i != and.getPredicates().length - 1)
					sb = sb.append(" ");
			}
			sb = sb.append(")");
		
	}

	public void printFormat(Implication implication, StringBuffer sb,
			String indent) {
		sb = sb.append("(implies ");
		implication.getLeft().acceptPrint(this, sb, indent);
		sb = sb.append(" ");
		implication.getRight().acceptPrint(this, sb, indent);
		sb = sb.append(")");
	}

	public void printFormat(Equivalence equivalence, StringBuffer sb,
			String indent) {
		sb = sb.append("(iff ");
		equivalence.getLeft().acceptPrint(this, sb, indent);
		sb = sb.append(" ");
		equivalence.getRight().acceptPrint(this, sb, indent);
		sb = sb.append(")");
	}

	public void printFormat(ForAll forAll, StringBuffer sb, String indent) {
		// has quantification for SMT format
		int new_number_not_var_quantified=0;
		
		for (int i = 0; i < forAll.getIdentifiers().length; i++){ 
			if( extraFuns_Has(forAll.getIdentifier(i)) )
				new_number_not_var_quantified++;
			else if( extraPreds_Has(forAll.getIdentifier(i)) ){
				new_number_not_var_quantified++;
			}
		}
		
		// Caso todas as variaveis tenha se transformado em :extras 
		if( forAll.getIdentifiers().length  == new_number_not_var_quantified){
			
			forAll.getImplication().acceptPrint(this, sb, indent);
			
			
		}else{// Caso contrario, ou seja, exista pelo menos uma

			sb.append("(forall \n\t");
			int size=0 ;
			int i=0;
			for ( i = 0; i < forAll.getIdentifiers().length; i++) {
				if( !(extraFuns_Has(forAll.getIdentifier(i)) || extraPreds_Has(forAll.getIdentifier(i))) ){
					sb.append("(?");
					forAll.getIdentifier(i).acceptPrint(this, sb, indent);
					listVariablesQuantified.add( forAll.getIdentifier(i) ); size++;
					sb.append(" Int) ");
				}
			}
			sb.append("\n\t ");
			forAll.getImplication().acceptPrint(this, sb, indent);
			sb.append(")");
			// remove the variables quantified in scope of forall
			for(i=0;i<size;i++){
				listVariablesQuantified.removeLast();
			}
		}
	}

	public void printFormat(Exists exists, StringBuffer sb, String indent) {
		// has quantification for SMT format
		int new_number_not_var_quantified=0;
		
		for (int i = 0; i < exists.getIdentifiers().length; i++){ 
			if( extraFuns_Has(exists.getIdentifier(i)) )
				new_number_not_var_quantified++;
			else if( extraPreds_Has(exists.getIdentifier(i)) ){
				new_number_not_var_quantified++;
			}
		}
		
		// Caso todas as variaveis tenha se transformado em :extras 
		if( exists.getIdentifiers().length  == new_number_not_var_quantified){
			
			exists.getPredicate().acceptPrint(this, sb, indent);
			
			
		}else{// Caso contrario, ou seja, exista pelo menos uma

			sb.append("(forall \n\t");
			int size=0 ;
			int i=0;
			for ( i = 0; i < exists.getIdentifiers().length; i++) {
				if( !(extraFuns_Has(exists.getIdentifier(i)) || extraPreds_Has(exists.getIdentifier(i))) ){
					sb.append("(?");
					exists.getIdentifier(i).acceptPrint(this, sb, indent);
					listVariablesQuantified.add( exists.getIdentifier(i) ); size++;
					sb.append(" Int) ");
				}
			}
			sb.append("\n\t ");
			exists.getPredicate().acceptPrint(this, sb, indent);
			sb.append(")");
			// remove the variables quantified in scope of exists
			for(i=0;i<size;i++){
				listVariablesQuantified.removeLast();
			}
		}
		/*sb.append("(exists ");
		for (int i = 0; i < exists.getIdentifiers().length; i++) {
			exists.getIdentifier(i).acceptPrint(this, sb, indent);
			if (i != exists.getIdentifiers().length - 1)
				sb = sb.append(" ");
		}
		exists.getPredicate().acceptPrint(this, sb, indent);
		sb = sb.append(")");
		*/
	}

	public void printFormat(Not not, StringBuffer sb, String indent) {

		sb = sb.append("(not ");
		not.getPredicate().acceptPrint(this, sb, indent);

		sb = sb.append(")");
	}

	public void printFormat(LessThan lessThan, StringBuffer sb, String indent) {
		sb = sb.append("(< ");
		lessThan.getLeft().acceptPrint(this, sb, indent);
		sb = sb.append(" ");
		lessThan.getRight().acceptPrint(this, sb, indent);
		sb = sb.append(" )");
	}

	public void printFormat(LessThanOrEqual lessThanOrEqual, StringBuffer sb,
			String indent) {
		sb = sb.append("(<= ");
		lessThanOrEqual.getLeft().acceptPrint(this, sb, indent);
		sb = sb.append(" ");
		lessThanOrEqual.getRight().acceptPrint(this, sb, indent);
		sb = sb.append(" )");
	}

	public void printFormat(GreatherThan greatherThan, StringBuffer sb,
			String indent) {
		sb = sb.append("(> ");
		greatherThan.getLeft().acceptPrint(this, sb, indent);
		sb = sb.append(" ");
		greatherThan.getRight().acceptPrint(this, sb, indent);
		sb = sb.append(" )");
	}

	public void printFormat(GreatherThanOrEqual greatherThanOrEqual,
			StringBuffer sb, String indent) {
		sb = sb.append("(>= ");
		greatherThanOrEqual.getLeft().acceptPrint(this, sb, indent);
		sb = sb.append(" ");
		greatherThanOrEqual.getRight().acceptPrint(this, sb, indent);
		sb = sb.append(" )");
	}

	public void printFormat(Equal equal, StringBuffer sb, String indent) {
		sb = sb.append("(= ");
		equal.getLeft().acceptPrint(this, sb, indent);
		sb = sb.append(" ");
		equal.getRight().acceptPrint(this, sb, indent);
		sb = sb.append(")");
	}

	public void printFormat(NotEqual notEqual, StringBuffer sb, String indent) {
		
		sb = sb.append("(not (= ");
		notEqual.getLeft().acceptPrint(this, sb, indent);
		sb = sb.append(" ");
		notEqual.getRight().acceptPrint(this, sb, indent);
		sb = sb.append("))");
	}

	public void printFormat(EqualSet equalSet, StringBuffer sb, String indent) {
		
		if (equalSet.getLeft() instanceof BIdentifier &&
			equalSet.getRight() instanceof ExtensionSet  ){

			count_var+=1;
			
			Expression [] expressions = ((ExtensionSet)equalSet.getRight()).getExpressions();
			
			sb = sb.append("(and ");
			// print the elements included
			for (int i=0; i< expressions.length;i++ ){
				sb = sb.append("(in ");
				expressions[i].acceptPrint(this, sb, indent);
				sb = sb.append(" ");
				equalSet.getLeft().acceptPrint(this, sb, indent);
				sb = sb.append(")");
			}
			// Add o distinct
			sb.append("(distinct ");
			for (int i=0; i< expressions.length;i++ ){
				expressions[i].acceptPrint(this, sb, indent);
				sb.append(" ");
			}
			sb.append(")");
			
			sb.append("(forall (?e"+count_var+" Int)(implies (in ?e"+count_var+" ");
			equalSet.getLeft().acceptPrint(this, sb, indent);
			sb.append(")(or ");
			
			for (int i=0; i< expressions.length;i++ ){
				sb.append("(= ?e"+count_var+" ");
				expressions[i].acceptPrint(this, sb, indent);
				sb.append(")");
			
			}
			sb.append(") ) ) ) ");
			
			
			
		}else{
		
			sb.append("(= ");
			equalSet.getLeft().acceptPrint(this, sb, indent);
			sb.append(" ");
			equalSet.getRight().acceptPrint(this, sb, indent);
			sb.append(")");
		}
				

	}

	public void printFormat(NotEqualSet notEqualSet, StringBuffer sb,
			String indent) {
		sb.append("(not (= ");
		notEqualSet.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		notEqualSet.getRight().acceptPrint(this, sb, indent);
		sb.append("))");
	}

	public void printFormat(EqualSequence equalSequence, StringBuffer sb,
			String indent) {
		sb.append("(= ");
		equalSequence.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		equalSequence.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(NotEqualSequence notEqualSequence, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append("/= ");
		notEqualSequence.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		notEqualSequence.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(EqualBoolean equalBoolean, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append("= ");
		equalBoolean.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		equalBoolean.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(NotEqualBoolean notEqualBoolean, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append("/= ");
		notEqualBoolean.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		notEqualBoolean.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(EqualEnumerated equalEnumerated, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append("= ");
		equalEnumerated.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		equalEnumerated.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(NotEqualEnumerated notEqualEnumerated,
			StringBuffer sb, String indent) {
		sb.append("(");
		sb.append("/= ");
		notEqualEnumerated.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		notEqualEnumerated.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(EqualOrderedPair equalOrderedPair, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append("= ");
		equalOrderedPair.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		equalOrderedPair.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(NotEqualOrderedPair notEqualOrderedPair,
			StringBuffer sb, String indent) {
		sb.append("(");
		sb.append("/= ");
		notEqualOrderedPair.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		notEqualOrderedPair.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(In in, StringBuffer sb, String indent) {

		if (!printingAssumpions || (printingAssumpions && !was_typed(in))){
			
			sb.append("(in ");
			for (int i = 0; i < in.getExpressions().length; i++) {
				in.getExpression(i).acceptPrint(this, sb, indent);
				sb.append(" ");
			}
			in.getSet().acceptPrint(this, sb, indent);
			sb.append(")");
			
		}else
		{
			sb.append(" true ");
		}
	}
	
	public void printFormat(NotSetMemberShip notSetMemberShip, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append("not  (in ");
		for (int i = 0; i < notSetMemberShip.getExpressions().length; i++) {
			notSetMemberShip.getExpression(i).acceptPrint(this, sb, indent);
			if (i != notSetMemberShip.getExpressions().length - 1)
				sb.append(" ");
		}
		sb.append(" ");
		notSetMemberShip.getSet().acceptPrint(this, sb, indent);
		sb.append("))");
	}

	public void printFormat(Subset subset, StringBuffer sb, String indent) {
		sb.append("(");
		sb.append("subseteq ");
		for (int i = 0; i < subset.getExpressions().length; i++) {
			subset.getExpression(i).acceptPrint(this, sb, indent);
			sb.append(" ");
		}
		sb.append(" ");
		subset.getSet().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(StrictSubset strictSubset, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append("subset ");
		for (int i = 0; i < strictSubset.getExpressions().length; i++) {
			strictSubset.getExpression(i).acceptPrint(this, sb, indent);
			if (i != strictSubset.getExpressions().length - 1)
				sb.append(" ");
		}
		sb.append(" ");
		strictSubset.getSet().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(NotSubset notSubset, StringBuffer sb, String indent) {
		sb.append("(");
		sb.append("nsubseteq ");
		for (int i = 0; i < notSubset.getExpressions().length; i++) {
			notSubset.getExpression(i).acceptPrint(this, sb, indent);
			if (i != notSubset.getExpressions().length - 1)
				sb.append(" ");
		}
		sb.append(" ");
		notSubset.getSet().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(NotStrictSubset notStrictSubSet, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append("nsubset ");
		for (int i = 0; i < notStrictSubSet.getExpressions().length; i++) {
			notStrictSubSet.getExpression(i).acceptPrint(this, sb, indent);
			if (i != notStrictSubSet.getExpressions().length - 1)
				sb.append(" ");
		}
		sb.append(" ");
		notStrictSubSet.getSet().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(CartesianProduct cartesianProduct, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append("cross ");
		cartesianProduct.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		cartesianProduct.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(ParallelProduct parallelProduct, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append("|| ");
		parallelProduct.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		parallelProduct.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Relation relation, StringBuffer sb, String indent) {
		sb.append("(");
		sb.append("<-> ");
		relation.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		relation.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(TotalFunction totalFunction, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append("--> ");
		totalFunction.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		totalFunction.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(PartialFunction partialFunction, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append("+-> ");
		partialFunction.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		partialFunction.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(TotalSurjection totalSurjection, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append("-->> ");
		totalSurjection.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		totalSurjection.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(PartialSurjection partialSurjection,
			StringBuffer sb, String indent) {
		sb.append("(");
		sb.append("+->> ");
		partialSurjection.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		partialSurjection.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(TotalInjection totalInjection, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append(">-> ");
		totalInjection.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		totalInjection.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(PartialInjection partialInjection, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append(">+> ");
		partialInjection.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		partialInjection.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(TotalBijection totalBijection, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append(">->> ");
		totalBijection.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		totalBijection.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(PartialBijection partialBijection, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append(">+>> ");
		partialBijection.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		partialBijection.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Union union, StringBuffer sb, String indent) {
		sb.append("(");
		sb.append("cup ");
		union.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		union.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Intersection intersection, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append("cap ");
		intersection.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		intersection.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(SetMinus setMinus, StringBuffer sb, String indent) {
		sb.append("(");
		sb.append("setminus ");
		setMinus.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		setMinus.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Composition composition, StringBuffer sb,
			String indent) {
		sb.append("(");
		sb.append(";");
		composition.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		composition.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(DirectProduct directProduct, StringBuffer sb,
			String indent) {
		sb.append("(DirectProduct ");
		directProduct.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		directProduct.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(DomainRestriction domainRestriction,
			StringBuffer sb, String indent) {
		sb.append("(");
		sb.append("<| ");
		domainRestriction.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		domainRestriction.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(DomainSubstraction domainSubstraction,
			StringBuffer sb, String indent) {
		sb.append("(");
		sb.append("<<| ");
		domainSubstraction.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		domainSubstraction.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(RangeRestriction rangeRestriction, StringBuffer sb,
			String indent) {
		sb.append("(|>");
		rangeRestriction.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		rangeRestriction.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(RangeSubstraction rangeSubstraction,
			StringBuffer sb, String indent) {
		sb.append("(");
		sb.append("|>> ");
		rangeSubstraction.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		rangeSubstraction.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Overriding overriding, StringBuffer sb,
			String indent) {
		sb.append("(<+ ");
		overriding.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		overriding.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Image image, StringBuffer sb, String indent) {
		image.getLeft().acceptPrint(this, sb, indent);
		sb.append(" [");
		image.getRight().acceptPrint(this, sb, indent);
		sb.append("] ");
	}

	public void printFormat(ComprehensionSet comprehensionSet, StringBuffer sb,
			String indent) {
		sb.append("{");
		for (int i = 0; i < comprehensionSet.getIdentifiers().length; i++) {
			comprehensionSet.getIdentifier(i).acceptPrint(this, sb, indent);
			if (i != comprehensionSet.getIdentifiers().length - 1)
				sb.append(",");
		}
		sb.append(" | ");
		comprehensionSet.getPredicate().acceptPrint(this, sb, indent);
		sb.append("}");
	}

	public void printFormat(ExtensionSet extensionSet, StringBuffer sb,
			String indent) {

		if(1== extensionSet.getExpressions().length){
			sb.append("(singleton ");
			extensionSet.getExpression(0).acceptPrint(this, sb, indent);
			sb.append(" )");
			
		}else if (2== extensionSet.getExpressions().length){

			sb.append("(union ");
			extensionSet.getExpression(0).acceptPrint(this, sb, indent);
			extensionSet.getExpression(1).acceptPrint(this, sb, indent);
			sb.append(" )");
			
		}else if (2 < extensionSet.getExpressions().length ){
			
			addSizeSetsUseds(extensionSet.getExpressions().length);
			
			sb.append("(set"+extensionSet.getExpressions().length+" ");
			
			for (int i = 0; i < extensionSet.getExpressions().length; i++) {
				extensionSet.getExpression(i).acceptPrint(this, sb, indent);
			}
			sb.append(" )");
		}
		
	}
	private void addSizeSetsUseds(int number){
		
		
		int length = listSizeSetsUseds.size();
		
		for(int i=0;i<length;i++){
			if(listSizeSetsUseds.get(i)>number )continue; 
			else if(number != listSizeSetsUseds.get(i)){ // the last 
				listSizeSetsUseds.add(i, number);
				return;
			}
			else return;// the element has in List
			
		}
		// The first
		listSizeSetsUseds.add(length, number);
		
		
	}

	public void printFormat(QuantifiedUnion quantifiedUnion, StringBuffer sb,
			String indent) {
		sb.append("UNION ");
		for (int i = 0; i < quantifiedUnion.getIdentifiers().length; i++) {
			quantifiedUnion.getIdentifier(i).acceptPrint(this, sb, indent);
			if (i != quantifiedUnion.getIdentifiers().length - 1)
				sb.append(",");
		}
		sb.append(".(");
		quantifiedUnion.getPredicate().acceptPrint(this, sb, indent);
		sb.append(" | ");
		quantifiedUnion.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(QuantifiedIntersection quantifiedIntersection,
			StringBuffer sb, String indent) {
		sb.append("INTER ");
		for (int i = 0; i < quantifiedIntersection.getIdentifiers().length; i++) {
			quantifiedIntersection.getIdentifier(i).acceptPrint(this, sb,
					indent);
			if (i != quantifiedIntersection.getIdentifiers().length - 1)
				sb.append(",");
		}
		sb.append(".(");
		quantifiedIntersection.getPredicate().acceptPrint(this, sb, indent);
		sb.append(" | ");
		quantifiedIntersection.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(GeneralizedUnion generalizedUnion, StringBuffer sb,
			String indent) {
		sb.append("union (");
		for (int i = 0; i < generalizedUnion.getExpressions().length; i++) {
			generalizedUnion.getExpression(i).acceptPrint(this, sb, indent);
			if (i != generalizedUnion.getExpressions().length - 1)
				sb.append(",");
		}
		sb.append(")");
	}

	public void printFormat(GeneralizedIntersection generalizedIntersection,
			StringBuffer sb, String indent) {
		sb.append("inter (");
		for (int i = 0; i < generalizedIntersection.getExpressions().length; i++) {
			generalizedIntersection.getExpression(i).acceptPrint(this, sb,
					indent);
			if (i != generalizedIntersection.getExpressions().length - 1)
				sb.append(",");
		}
		sb.append(")");
	}

	public void printFormat(Lambda lambda, StringBuffer sb, String indent) {
		sb.append("% ");
		for (int i = 0; i < lambda.getIdentifiers().length; i++) {
			lambda.getIdentifier(i).acceptPrint(this, sb, indent);
			if (i != lambda.getIdentifiers().length - 1)
				sb.append(",");
		}
		sb.append(".(");
		lambda.getPredicate().acceptPrint(this, sb, indent);
		sb.append(" | ");
		lambda.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(IntegerSet integerSet, StringBuffer sb,
			String indent) {
		sb.append(integerSet.getValue());
	}

	public void printFormat(BooleanSet booleanSet, StringBuffer sb,
			String indent) {
		sb.append("boolean");
	}

	public void printFormat(StringSet stringSet, StringBuffer sb, String indent) {
		sb.append("STRING");
	}

	public void printFormat(EmptySet emptySet, StringBuffer sb, String indent) {
		sb.append(" emptyset ");
	}

	public void printFormat(Interval interval, StringBuffer sb, String indent) {
		sb.append("(range ");
		interval.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		interval.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(PowerSet powerSet, StringBuffer sb, String indent) {
		sb.append("POW (");
		for (int i = 0; i < powerSet.getSets().length; i++) {
			powerSet.getSet(i).acceptPrint(this, sb, indent);
			if (i != powerSet.getSets().length - 1)
				sb.append(",");
		}
		sb.append(")");
	}

	public void printFormat(NonEmptySubsets nonEmptySubsets, StringBuffer sb,
			String indent) {
		sb.append("(power1 ");
		for (int i = 0; i < nonEmptySubsets.getSets().length; i++) {
			nonEmptySubsets.getSet(i).acceptPrint(this, sb, indent);
			if (i != nonEmptySubsets.getSets().length - 1)
				sb.append(" ");
		}
		sb.append(")");
	}

	public void printFormat(FinitePowerSet finitePowerSet, StringBuffer sb,
			String indent) {
		sb.append("FIN (");
		for (int i = 0; i < finitePowerSet.getSets().length; i++) {
			finitePowerSet.getSet(i).acceptPrint(this, sb, indent);
			if (i != finitePowerSet.getSets().length - 1)
				sb.append(",");
		}
		sb.append(")");
	}

	public void printFormat(NonEmptyFiniteSubsets nonEmptyFiniteSubsets,
			StringBuffer sb, String indent) {
		sb.append("FIN1 (");
		for (int i = 0; i < nonEmptyFiniteSubsets.getSets().length; i++) {
			nonEmptyFiniteSubsets.getSet(i).acceptPrint(this, sb, indent);
			if (i != nonEmptyFiniteSubsets.getSets().length - 1)
				sb.append(",");
		}
		sb.append(")");
	}

	public void printFormat(Identity identity, StringBuffer sb, String indent) {
		sb.append("id(");
		identity.getSet().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Inverse inverse, StringBuffer sb, String indent) {
		inverse.getSet().acceptPrint(this, sb, indent);
		sb.append("~");
	}

	public void printFormat(Projection1 projection1, StringBuffer sb,
			String indent) {
		sb.append("(second ");
		projection1.getSet1().acceptPrint(this, sb, indent);
		sb.append(" ");
		projection1.getSet2().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Projection2 projection2, StringBuffer sb,
			String indent) {
		sb.append("(second ");
		projection2.getSet1().acceptPrint(this, sb, indent);
		sb.append(" ");
		projection2.getSet2().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Iterate iterate, StringBuffer sb, String indent) {
		iterate.getSet().acceptPrint(this, sb, indent);
		sb.append("iterate (");
		iterate.getN().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Closure closure, StringBuffer sb, String indent) {
		sb.append("closure (");
		closure.getSet().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Closure1 closure1, StringBuffer sb, String indent) {
		sb.append("closure1 (");
		closure1.getSet().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Domain domain, StringBuffer sb, String indent) {
		sb.append("<b>dom</b> (");
		domain.getRelation().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Range range, StringBuffer sb, String indent) {
		sb.append("ran (");
		range.getRelation().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Fnc fnc, StringBuffer sb, String indent) {
		sb.append("fnc (");
		fnc.getRelation().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Rel rel, StringBuffer sb, String indent) {
		sb.append("rel (");
		rel.getRelation().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(CallFunction callFunction, StringBuffer sb,
			String indent) {
		callFunction.getExpression().acceptPrint(this, sb, indent);
		sb.append("(");
		callFunction.getParametre().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Max max, StringBuffer sb, String indent) {
		sb.append("max (");
		max.getIntegerSet().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Min min, StringBuffer sb, String indent) {
		sb.append("min (");
		min.getIntegerSet().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Card card, StringBuffer sb, String indent) {
		sb.append("card (");
		card.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Concatenate concatenate, StringBuffer sb,
			String indent) {
		concatenate.getLeft().acceptPrint(this, sb, indent);
		sb.append("^");
		concatenate.getRight().acceptPrint(this, sb, indent);
	}

	public void printFormat(Append append, StringBuffer sb, String indent) {
		append.getLeft().acceptPrint(this, sb, indent);
		sb.append("\\|/");
		append.getRight().acceptPrint(this, sb, indent);
	}

	public void printFormat(Prepend prepend, StringBuffer sb, String indent) {
		prepend.getLeft().acceptPrint(this, sb, indent);
		sb.append("/|\\");
		prepend.getRight().acceptPrint(this, sb, indent);
	}

	public void printFormat(Prefix prefix, StringBuffer sb, String indent) {
		prefix.getLeft().acceptPrint(this, sb, indent);
		sb.append("->");
		prefix.getRight().acceptPrint(this, sb, indent);
	}

	public void printFormat(Suffix suffix, StringBuffer sb, String indent) {
		suffix.getLeft().acceptPrint(this, sb, indent);
		sb.append("<-");
		suffix.getRight().acceptPrint(this, sb, indent);
	}

	public void printFormat(EmptySequence emptySequence, StringBuffer sb,
			String indent) {
		sb.append("<>");
	}

	public void printFormat(ExtensionSequence extensionSequence,
			StringBuffer sb, String indent) {
		sb.append("<");
		for (int i = 0; i < extensionSequence.getExpressions().length; i++) {
			extensionSequence.getExpression(i).acceptPrint(this, sb, indent);
			if (i != extensionSequence.getExpressions().length - 1)
				sb.append(",");
		}
		sb.append(">");
	}

	public void printFormat(Size size, StringBuffer sb, String indent) {
		sb.append("size (");
		size.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(First first, StringBuffer sb, String indent) {
		sb.append("(first ");
		first.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Last last, StringBuffer sb, String indent) {
		sb.append("last (");
		last.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Front front, StringBuffer sb, String indent) {
		sb.append("front (");
		front.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Tail tail, StringBuffer sb, String indent) {
		sb.append("tail (");
		tail.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Reverse reverse, StringBuffer sb, String indent) {
		sb.append("rev (");
		reverse.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Seq seq, StringBuffer sb, String indent) {
		sb.append("seq (");
		seq.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Seq1 seq1, StringBuffer sb, String indent) {
		sb.append("seq1(");
		seq1.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(ISeq iSeq, StringBuffer sb, String indent) {
		sb.append("iseq (");
		iSeq.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(ISeq1 iSeq1, StringBuffer sb, String indent) {
		sb.append("iseq1 (");
		iSeq1.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Permutation permutation, StringBuffer sb,
			String indent) {
		sb.append("perm (");
		permutation.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(GeneralizedConcatenation generalizedConcatenation,
			StringBuffer sb, String indent) {
		sb.append("conc (");
		for (int i = 0; i < generalizedConcatenation.getExpressions().length; i++) {
			generalizedConcatenation.getExpression(i).acceptPrint(this, sb,
					indent);
			if (i != generalizedConcatenation.getExpressions().length - 1)
				sb.append(",");
		}
		sb.append(")");
	}

	public void printFormat(IntegerValue integerValue, StringBuffer sb,
			String indent) {
		integerValue.getValue().acceptPrint(this, sb, indent);
	}

	public void printFormat(UnaryMinus unaryMinus, StringBuffer sb,
			String indent) {
		sb.append("(~ ");
		unaryMinus.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Plus plus, StringBuffer sb, String indent) {
		sb.append("(+ ");
		plus.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		plus.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Minus minus, StringBuffer sb, String indent) {
		sb.append("(");
		sb.append("- ");
		minus.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		minus.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Division division, StringBuffer sb, String indent) {
		division.getLeft().acceptPrint(this, sb, indent);
		sb.append("/");
		division.getRight().acceptPrint(this, sb, indent);
	}

	public void printFormat(Product product, StringBuffer sb, String indent) {
		sb.append("(* ");
		product.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		product.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Modulo modulo, StringBuffer sb, String indent) {
		sb.append("(mod");
		modulo.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		modulo.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Power power, StringBuffer sb, String indent) {
		power.getLeft().acceptPrint(this, sb, indent);
		sb.append("**");
		power.getRight().acceptPrint(this, sb, indent);
	}

	public void printFormat(Pi pi, StringBuffer sb, String indent) {
		sb.append("PI ");
		for (int i = 0; i < pi.getIdentifiers().length; i++) {
			pi.getIdentifier(i).acceptPrint(this, sb, indent);
			if (i != pi.getIdentifiers().length)
				sb.append(",");
		}
		sb.append(".(");
		pi.getPredicate().acceptPrint(this, sb, indent);
		sb.append(" | ");
		pi.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Sigma sigma, StringBuffer sb, String indent) {
		sb.append("SIGMA ");
		for (int i = 0; i < sigma.getIdentifiers().length; i++) {
			sigma.getIdentifier(i).acceptPrint(this, sb, indent);
			if (i != sigma.getIdentifiers().length)
				sb.append(",");
		}
		sb.append(".(");
		sigma.getPredicate().acceptPrint(this, sb, indent);
		sb.append(" | ");
		sigma.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Succ succ, StringBuffer sb, String indent) {
		sb.append("succ (");
		succ.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(Pred pred, StringBuffer sb, String indent) {
		sb.append("pred (");
		pred.getExpression().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(BooleanExpression booleanExpression,
			StringBuffer sb, String indent) {
		sb.append("bool (");
		booleanExpression.getPredicate().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(OrderedPair orderedPair, StringBuffer sb,
			String indent) {
		sb.append("(ord_pair ");
		orderedPair.getLeft().acceptPrint(this, sb, indent);
		sb.append(" ");
		orderedPair.getRight().acceptPrint(this, sb, indent);
		sb.append(")");
	}

	public void printFormat(ArrayElement arrayElement, StringBuffer sb,
			String indent) {
		arrayElement.getIdentifier().acceptPrint(this, sb, indent);
		for (int i = 0; i < arrayElement.getElements().length; i++) {
			sb.append("(");
			arrayElement.getElement(i).acceptPrint(this, sb, indent);
			sb.append(")");
		}
	}

	public void printFormat(BInteger bInteger, StringBuffer sb, String indent) {
		sb.append(bInteger.getValue());
	}

	public void printFormat(BBoolean bBoolean, StringBuffer sb, String indent) {
		sb.append(bBoolean.getValue());
	}

	public void printFormat(BIdentifier bIdentifier, StringBuffer sb,String indent) {
		if(var_quantified(bIdentifier))
			sb.append(" ?"+bIdentifier.getValue());	
		else
			sb.append(bIdentifier.getValue());
	}

	public void printFormat(BEnumeratedValue bEnumeratedValue, StringBuffer sb,
			String indent) {
		sb.append(bEnumeratedValue.getValue());
	}

	public void printFormat(BPreviousValue bPreviousValue, StringBuffer sb,
			String indent) {
		bPreviousValue.getIdentifier().acceptPrint(this, sb, indent);
		sb.append("$0");
	}

	public void printFormat(BString bString, StringBuffer sb, String indent) {
		sb.append(bString.getValue());
	}
	
	public void printFormat(EntityInstance entityInstance, StringBuffer sb,
			String indent){ 
		sb.append(entityInstance.getInstance());
	}
	
	public void printFormat(EntityLocalization entityLocation, StringBuffer sb,
			String indent){
		sb.append(entityLocation.getLocalization());
	}
	
	public void printFormat(EntityName entityName, StringBuffer sb,
			String indent){ 
		
		sb.append(entityName.getName());
	}
	
	public void printFormat(TypeBool typeBool, StringBuffer sb,
			String indent){ 
		sb.append("BOOL");
	}
	
	public void printFormat(TypeIdentifier typeIdentifier, StringBuffer sb,
			String indent){
		sb.append(typeIdentifier.getTypeIdentifier());
		
	}
	
	public void printFormat(TypeParameter typeParameter, StringBuffer sb,
			String indent){ 
		typeParameter.getType().acceptPrint(this, sb, indent.concat("  "));
	}
	
	public void printFormat(TypeResult typeResult, StringBuffer sb,
			String indent){ 
		typeResult.getType().acceptPrint(this, sb, indent.concat("  "));
	}
	
	public void printFormat(TypeCartesianProduct typeCartesianProduct, StringBuffer sb,
			String indent){
		sb.append(" x ");
		typeCartesianProduct.getBTypeLeft().acceptPrint(this, sb, indent);
		typeCartesianProduct.getBTypeRight().acceptPrint(this, sb, indent);
	}
	
	public void printFormat(TypeReference typeReference, StringBuffer sb,
			String indent){ 
		sb.append(typeReference.getReference());
		
	}
	
	public void printFormat(TypePowerSet typePowerSet, StringBuffer sb,
			String indent){  
		sb.append("POW(");
		typePowerSet.getBType().acceptPrint(this, sb, indent);
		sb.append(")");
	}
	
	public void printFormat(TypeParameters typeParameters, StringBuffer sb,
			String indent){ 
		for (int i = 0; i < typeParameters.getParameters().length; i++) {
			typeParameters.getParameter(i).acceptPrint(this, sb, indent);
			if (i != typeParameters.getParameters().length - 1)
				sb.append(",");
		}
		
	}
	
	public void printFormat(TypeResults typeResults, StringBuffer sb,
			String indent){ 
		
		for (int i = 0; i < typeResults.getResults().length; i++) {
			typeResults.getResult(i).acceptPrint(this, sb, indent);
			if (i != typeResults.getResults().length - 1)
				sb.append(",");
		}
	}
	
	public void printFormat(TypeString typeString, StringBuffer sb,
			String indent){ 
		sb.append("STRING");
	}
	
	public void printFormat(TypeInteger entityType, StringBuffer sb,
			String indent){ 
		sb.append("Z");
	}
	
	public void printFormat(EntityType entityType, StringBuffer sb,
			String indent){
		entityType.getBType().acceptPrint(this, sb, indent);
		
	}
	
	private void printExtras(StringBuffer sb){
		BIdentifier tmp;
		
		/*
		 *dessa forma o Havey reconheca o operador mod como uma funcao 
		 *constante. No entanto, nao considerará as propriedades do harvey
		 *nas demais provas. 
		 *TODO  mandar o modulo
		 */
		sb.append(" :extrafuns ((MININT Int)\n"+
				"                 (MAXINT Int) \n"+
				"                 (mod Int Int Int))\n");		
		
		
		int sizeExtra = pOLabel.getExtrafuns_smt().size();
		
		if (sizeExtra >=1){
			 tmp = (BIdentifier) pOLabel.getExtrafuns_smt().get(0);
			sb.append(" :extrafuns ( ("+ tmp.getValue()+" Int )");
			
					
			for(int i=1;i<sizeExtra;i++){
				tmp = (BIdentifier) pOLabel.getExtrafuns_smt().get(i);
				sb.append("\n\t\t("+ tmp.getValue()+" Int )");	
			}
			sb.append(")\n");
	
		}
		
		sizeExtra = pOLabel.getExtrapreds_smt().size();
		sb.append(" :extrapreds ((INTEGER Int)\n"+
		"                   (NATURAL Int)\n" +
	    "                   (FINSET Int)\n" +
	    "                   (NATURAL_1 Int))\n");
	
		
		if (sizeExtra >=1){
			 tmp = (BIdentifier) pOLabel.getExtrapreds_smt().get(0);
			sb.append(" :extrapreds ( ("+ tmp.getValue()+" Int )");
			
					
			for(int i=1;i<sizeExtra;i++){
				tmp = (BIdentifier) pOLabel.getExtrapreds_smt().get(i);
				sb.append("\n\t\t("+ tmp.getValue()+" Int )");	
			}
			sb.append(")\n");
	
		}
		
	}
	private void printAssumptions(StringBuffer sb){
		Predicate tmp;
		printingAssumpions = true;
		
		sb.append(" :assumption (= MININT (~ 2147483647) )\n"+
		" :assumption (= MAXINT 2147483647)\n"+
		" :assumption (forall (?i Int) (iff (in ?i INTEGER) (and (<= MININT ?i) (<= ?i MAXINT))))\n"+
		" :assumption (forall (?i Int) (iff (in ?i NATURAL) (and (<= 0 ?i) (<= ?i MAXINT))))\n"  +
		" :assumption (forall (?i Int) (iff (in ?i NATURAL_1) (and (< 0 ?i) (<= ?i MAXINT))))\n" +
		" :assumption (forall (?x Int) (?y Int) (implies (and (>= ?x 0) (> ?y 0)) (and (<= (mod ?x ?y) 0)" +
		" (< (mod ?x ?y) ?y))))\n"
		
		);
		
		int sizeAssumption = pOLabel.getAssumptions().size();

			for(int i=0;i<sizeAssumption;i++){
				
				tmp = pOLabel.getAssumptions().get(i);
				
				if(tmp instanceof In &&
						was_typed((In)tmp))continue;
				
				sb.append(" :assumption ");
				tmp.acceptPrint(this, sb, "");
				sb.append("\n");	
			}
			
			
			printingAssumpions = false;
	
	}
	private boolean was_typed(In in){
		boolean typed = ( extraPreds_Has((BIdentifier)in.getExpressions()[0]) ||
				  extraFuns_Has( (BIdentifier) in.getExpressions()[0]));
		
		try {	
			
			
			if(  typed &&
				( ( in.getSet() instanceof NonEmptySubsets &&
				  ((Expression[])((NonEmptySubsets)in.getSet()).getSets())[0] instanceof IntegerSet )
				 ||
				  (in.getSet() instanceof IntegerSet  /*&& 
						  ((IntegerSet)in.getSet()).getValue().equals("NATURAL") */ )
				)
			
			){
				return true;
			}
		
		} catch (Exception e) {
			System.err.print(e.getMessage());
		}
		// TODO: handle exception
		return false;
	}
	
	public boolean var_quantified(BIdentifier id){
		int s = listVariablesQuantified.size(); 
		
		for(int i=0; i<s;i++){
		  if ( listVariablesQuantified.get(i).getValue().equals(id.getValue()))
			  return true;
		}
		return false;
		
	}
	public boolean extraFuns_Has(BIdentifier id){
		int s =pOLabel.getExtrafuns_smt().size(); 
		
		for(int i=0; i<s;i++){
		  if (pOLabel.getExtrafuns_smt().get(i).getValue().equals(id.getValue()))
			  return true;
		}
		return false;
		
	}
	public boolean extraPreds_Has(BIdentifier id){
		int s =pOLabel.getExtrapreds_smt().size(); 
		
		for(int i=0; i<s;i++){
		  if (pOLabel.getExtrapreds_smt().get(i).getValue().equals(id.getValue()))
			  return true;
		}
		return false;
		
	}
	/*
	 * PredicateExpression -CLasse inserida para transformacao em Circus
	 */
	public void printFormat(PredicateExpression predicateExpression, StringBuffer sb, String indent) {
		predicateExpression.getExpression().acceptPrint(this, sb, indent);
	}
}
