package zb2smt.bol;

import zb2smt.IPOPrint;

public class And extends Predicate {
	Predicate[] predicates;

	public And() {
	}

	public void setFields(BObject[] values) {
		predicates = new Predicate[values.length];
		for (int i = 0; i < values.length; i += 1) {
			predicates[i] = ((Predicate) values[i]);
		}
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<idents.length;i++){
			if(!predicates[i].isFree(idents)){
				return false;
			}
		}
		return true;
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("(");
		for (int i = 0; i < predicates.length; i++) {
			sb = sb.append(indent);
			predicates[i].toBString(sb, indent);
			if (i != predicates.length - 1)
				sb = sb.append(" &\n");
		}
		sb = sb.append(")");
	}*/

	public Predicate cloneObject() {
		And andClone;
		BObject[] bObjectClone;
		int i;
		andClone = new And();
		bObjectClone = new BObject[predicates.length];
		for (i = 0; i < bObjectClone.length; i++) {
			bObjectClone[i] = predicates[i].cloneObject();
		}
		andClone.setFields(bObjectClone);
		return andClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		boolean thereare_change = false;
		BObject[] bObject;
		int i;
		bObject = new BObject[predicates.length];
		for (i = 0; i < bObject.length; i++) {
			bObject[i] = predicates[i].substitute(dest, src);
			if (bObject[i] != this.predicates[i])
				thereare_change = true;
		}
		if (!thereare_change)
			return this;
		else {
			And a = new And();
			a.setFields(bObject);
			return a;
		}
	}*/

	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

	public Predicate[] getPredicates() {
		return predicates;
	}

	public void setPredicates(Predicate[] predicates) {
		this.predicates = predicates;
	}

	public Predicate getPredicate(int i) {
		return predicates[i];
	}

	public void setPredicate(Predicate predicate, int i) {
		this.predicates[i] = predicate;
	}
}