package zb2smt.bol;

import zb2smt.IPOPrint;


public class Append extends SequenceExpression {
	Expression left;

	Expression right;

	public Append() {
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public void setFields(BObject[] values) {
		left = (Expression) values[0];
		right = (Expression) values[1];
	}

	/*public void toBString(StringBuffer sb, String indent) {
		left.toBString(sb, indent);
		sb = sb.append("\\|/");
		right.toBString(sb, indent);
	}*/
	
	public boolean isFree(BIdentifier[] idents){
		return left.isFree(idents) && right.isFree(idents);
	}

	public boolean findDependency(BIdentifier bIdentifier) {
		return left.findDependency(bIdentifier)
				|| right.findDependency(bIdentifier);
	}

	public Expression cloneObject() {
		Append appendClone;
		appendClone = new Append();
		appendClone.left = left.cloneObject();
		appendClone.right = right.cloneObject();
		return appendClone;
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*
	public BObject substitute(BIdentifier[] dest, Expression[] src) {
		Append appendClone;
		Expression left = (Expression) this.left.substitute(dest, src);
		Expression right = (Expression) this.right.substitute(dest, src);
		if (left != this.left || right != this.right) {
			appendClone = new Append();
			appendClone.left = left;
			appendClone.right = right;
			return appendClone;
		} else {
			return this;
		}
	}
	*/

	public Expression getLeft() {
		return left;
	}

	public void setLeft(Expression left) {
		this.left = left;
	}

	public Expression getRight() {
		return right;
	}

	public void setRight(Expression right) {
		this.right = right;
	}
}