package zb2smt.bol;

import zb2smt.IPOPrint;


public class ArrayElement extends BBaseElement {
	BIdentifier identifier;

	Expression[] elements;

	public ArrayElement() {
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public void setFields(BObject[] values) {
		int i = 0;
		identifier = (BIdentifier) values[i];
		i += 1;
		elements = new Expression[values.length - 1];
		for (; i < values.length; i += 1) {
			elements[i - 1] = ((Expression) values[i]);
		}
	}

	/*public void toBString(StringBuffer sb, String indent) {
		identifier.toBString(sb, indent);
		for (int i = 0; i < elements.length; i++) {
			sb = sb.append("(");
			elements[i].toBString(sb, indent);
			sb = sb.append(")");
		}
	}*/
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	public boolean findDependency(BIdentifier bIdentifier) {
		for(int i=0;i<elements.length;i++){
			if(elements[i].findDependency(bIdentifier))
				return true;
		}
		return false;
	}

	public Expression cloneObject() {
		ArrayElement arrayElementClone;
		arrayElementClone = new ArrayElement();
		arrayElementClone.identifier = (BIdentifier) identifier.cloneObject();
		arrayElementClone.elements = new Expression[elements.length];
		for (int i = 0; i < elements.length; i++) {
			arrayElementClone.elements[i] = elements[i].cloneObject();
		}
		return arrayElementClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		System.out
				.println("ArrayElement nao implementado pra o m�odo substitute(BIdentifier[] dest, Expression[] src)");
		return this.cloneObject();
	}*/
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<idents.length;i++){
			if(idents[i].getValue().equals(identifier.getValue())){
				return false;
			}
		}
		for(int i=0;i<elements.length;i++){
			if(!elements[i].isFree(idents)){
				return false;
			}
		}
		return true;
	}
	
	public Expression[] getElements() {
		return elements;
	}

	public void setElements(Expression[] elements) {
		this.elements = elements;
	}

	public BIdentifier getIdentifier() {
		return identifier;
	}

	public void setIdentifier(BIdentifier identifier) {
		this.identifier = identifier;
	}

	public Expression getElement(int i) {
		return elements[i];
	}

	public void setElement(Expression element, int i) {
		this.elements[i] = element;
	}
}