package zb2smt.bol;


public class BecomeEqual extends Substitution {
	BIdentifier[] identifiers;

	Expression[] expressions;

	public BecomeEqual() {
	}

	public void setFields(BObject[] values) {
		int moitie = values.length / 2;
		int i, j;
		identifiers = new BIdentifier[moitie];
		expressions = new Expression[moitie];
		for (i = 0; i < moitie; i += 1) {
			identifiers[i] = (BIdentifier) values[i];
		}
		for (j = 0; j < moitie; j += 1, i += 1) {
			expressions[j] = (Expression) values[i];
		}
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent);
		for (int i = 0; i < identifiers.length; i++) {
			identifiers[i].toBString(sb, indent);
			if (i != identifiers.length - 1)
				sb = sb.append(",");
		}
		sb = sb.append(" := ");
		for (int i = 0; i < expressions.length; i++) {
			expressions[i].toBString(sb, indent);
			if (i != expressions.length - 1)
				sb = sb.append(",");
		}
	}*/

	public Predicate acceptPOGSubstitution(IBVisitorNodes pOG, Predicate inv) {
		return pOG.visitNode(inv, this);
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<identifiers.length;i++){
			if(!identifiers[i].isFree(idents) ||
					!expressions[i].isFree(idents)){
				return false;
			}
		}
		return true;
	}

	public Expression[] getExpressions() {
		return expressions;
	}

	public void setExpressions(Expression[] expressions) {
		this.expressions = expressions;
	}

	public BIdentifier[] getIdentifiers() {
		return identifiers;
	}

	public void setIdentifiers(BIdentifier[] identifiers) {
		this.identifiers = identifiers;
	}

	public Expression getExpression(int i) {
		return expressions[i];
	}

	public void setExpression(Expression expression, int i) {
		this.expressions[i] = expression;
	}

	public BIdentifier getIdentifier(int i) {
		return identifiers[i];
	}

	public void setIdentifier(BIdentifier identifier, int i) {
		this.identifiers[i] = identifier;
	}
}