package zb2smt.bol;

import zb2smt.IPOPrint;

public class BooleanExpression extends Expression {
	Predicate predicate;

	public BooleanExpression() {
	}

	public void setFields(BObject[] values) {
		predicate = (Predicate) values[0];
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("bool (");
		predicate.toBString(sb, indent);
		sb = sb.append(")");
	}*/

	public boolean findDependency(BIdentifier bIdentifier) {
		return false;
	}

	public Expression cloneObject() {
		BooleanExpression booleanExpressionClone;
		booleanExpressionClone = new BooleanExpression();
		booleanExpressionClone.predicate = predicate.cloneObject();
		return booleanExpressionClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		BooleanExpression booleanExpressionClone;
		Predicate pred = (Predicate) predicate.substitute(dest, src);
		if (pred != predicate) {
			booleanExpressionClone = new BooleanExpression();
			booleanExpressionClone.predicate = pred;
			return booleanExpressionClone;
		} else {
			return this;
		}
	}*/
	
	public boolean isFree(BIdentifier[] idents){
		return predicate.isFree(idents);
	}

	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

	public Predicate getPredicate() {
		return predicate;
	}

	public void setPredicate(Predicate predicate) {
		this.predicate = predicate;
	}
}