package zb2smt.bol;

import zb2smt.IPOPrint;

public class ComprehensionSet extends SetExpression {
	BIdentifier[] identifiers;

	Predicate predicate;

	public ComprehensionSet() {
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public void setFields(BObject[] values) {
		int i = 0;
		identifiers = new BIdentifier[values.length - 1];
		for (i = values.length - 2; i > -1; i -= 1) {
			identifiers[i] = (BIdentifier) values[i];
		}
		predicate = (Predicate) values[values.length - 1];
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("{");
		for (int i = 0; i < identifiers.length; i++) {
			identifiers[i].toBString(sb, indent);
			if (i != identifiers.length - 1)
				sb = sb.append(",");
		}
		sb = sb.append(" | ");
		predicate.toBString(sb, indent);
		sb = sb.append("}");
	}*/
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<identifiers.length;i++){
			if(!identifiers[i].isFree(idents)){
				return false;
			}
		}
		return predicate.isFree(idents);
	}

	public boolean findDependency(BIdentifier bIdentifier) {
		System.out
				.println("O metodo findDependency ainda nao esta implementado para estah expressao");
		return false;
	}

	public Expression cloneObject() {

		ComprehensionSet comprehensionSetClone = new ComprehensionSet();

		for (int i = identifiers.length; i > 0; i--) {
			comprehensionSetClone.identifiers[i] = (BIdentifier) this.identifiers[i]
					.cloneObject();
		}
		comprehensionSetClone.predicate = (Predicate) this.predicate
				.cloneObject();
		return comprehensionSetClone;

	}

	public BIdentifier[] getIdentifiers() {
		return identifiers;
	}

	public void setIdentifiers(BIdentifier[] identifiers) {
		this.identifiers = identifiers;
	}

	public Predicate getPredicate() {
		return predicate;
	}

	public void setPredicate(Predicate predicate) {
		this.predicate = predicate;
	}

	public BIdentifier getIdentifier(int i) {
		return identifiers[i];
	}

	public void setIdentifiers(BIdentifier identifier, int i) {
		this.identifiers[i] = identifier;
	}

}