package zb2smt.bol;

import zb2smt.IPOPrint;

public class Exists extends Predicate {
	BIdentifier[] identifiers;

	Predicate predicate;

	public Exists() {
	}

	public void setFields(BObject[] values) {
		int i = 0;
		identifiers = new BIdentifier[values.length - 1];
		for (i = values.length - 2; i > -1; i -= 1) {
			identifiers[i] = (BIdentifier) values[i];
		}
		predicate = (Predicate) values[values.length - 1];
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<identifiers.length;i++){
			if(!identifiers[i].isFree(idents)){
				return false;
			}
		}
		return predicate.isFree(idents);
	}

	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	
	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("(");
		sb = sb.append("# ");
		for (int i = 0; i < identifiers.length; i++) {
			identifiers[i].toBString(sb, indent);
			if (i != identifiers.length - 1)
				sb = sb.append(",");
		}
		sb = sb.append(".(");
		predicate.toBString(sb, indent);
		sb = sb.append(")");
		sb = sb.append(")");
	}*/

	public Predicate cloneObject() {
		Exists existsClone;
		BObject[] bObjectClone;
		int i;
		existsClone = new Exists();
		bObjectClone = new BObject[identifiers.length + 1];
		for (i = 0; i < bObjectClone.length - 1; i++) {
			bObjectClone[i] = identifiers[i].cloneObject();
		}
		bObjectClone[bObjectClone.length - 1] = predicate.cloneObject();
		existsClone.setFields(bObjectClone);
		return existsClone;
	}
	
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		System.out
				.println("Exists nao implementado o m???odo substitute(BIdentifier[] dest, Expression[] src) ");
		return this;
	} */

	public BIdentifier[] getIdentifiers() {
		return identifiers;
	}

	public void setIdentifiers(BIdentifier[] identifiers) {
		this.identifiers = identifiers;
	}

	public Predicate getPredicate() {
		return predicate;
	}

	public void setPredicate(Predicate predicate) {
		this.predicate = predicate;
	}

	public BIdentifier getIdentifier(int i) {
		return identifiers[i];
	}

	public void setIdentifiers(BIdentifier identifier, int i) {
		this.identifiers[i] = identifier;
	}
}