package zb2smt.bol;

import zb2smt.IPOPrint;

public class ExtensionSequence extends SequenceExpression {
	Expression[] expressions;

	public ExtensionSequence() {
	}

	public void setFields(BObject[] values) {
		expressions = new Expression[values.length];
		for (int i = 0; i < values.length; i += 1) {
			expressions[i] = ((Expression) values[i]);
		}
	}
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<expressions.length;i++){
			if(!expressions[i].isFree(idents)){
				return false;
			}
		}
		return true;
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("<");
		for (int i = 0; i < expressions.length; i++) {
			expressions[i].toBString(sb, indent);
			if (i != expressions.length - 1)
				sb = sb.append(",");
		}
		sb = sb.append(">");
	}*/

	public boolean findDependency(BIdentifier arg0) {
		for (int i = 0; i < expressions.length; i++) {
			if (expressions[i].findDependency(arg0))
				return true;
		}
		return false;
	}

	public Expression cloneObject() {
		ExtensionSequence extensionSequenceClone;
		BObject[] bObjectClone;
		extensionSequenceClone = new ExtensionSequence();
		bObjectClone = new Expression[expressions.length];
		for (int i = 0; i < expressions.length; i++) {
			bObjectClone[i] = expressions[i].cloneObject();
		}
		extensionSequenceClone.setFields(bObjectClone);
		return extensionSequenceClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		ExtensionSequence extensionSequenceClone;
		BObject[] bObjectClone;
		Expression exp;
		boolean mudou = false;
		bObjectClone = new Expression[this.expressions.length];
		for (int i = 0; i < expressions.length; i++) {
			exp = (Expression) expressions[i].substitute(dest, src);
			if (exp != expressions[i]) {
				bObjectClone[i] = exp;
				mudou = true;
			} else {
				bObjectClone[i] = expressions[i];
			}
		}
		if (mudou) {
			extensionSequenceClone = new ExtensionSequence();
			extensionSequenceClone.setFields(bObjectClone);
			return extensionSequenceClone;
		} else {
			return this;
		}
	} */
	
	public Expression[] getExpressions() {
		return expressions;
	}

	public void setExpressions(Expression[] expressions) {
		this.expressions = expressions;
	}

	public Expression getExpression(int i) {
		return expressions[i];
	}

	public void setExpression(Expression expression, int i) {
		this.expressions[i] = expression;
	}
}