package zb2smt.bol;

import zb2smt.IPOPrint;

public class ExtensionSet extends SetExpression {
	Expression[] expressions;

	public ExtensionSet() {
	}

	public void setFields(BObject[] values) {
		expressions = new Expression[values.length];
		for (int i = 0; i < values.length; i += 1) {
			expressions[i] = ((Expression) values[i]);
		}
	}

	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<expressions.length;i++){
			if(!expressions[i].isFree(idents)){
				return false;
			}
		}
		return true;
	}
	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("{");
		for (int i = 0; i < expressions.length; i++) {
			expressions[i].toBString(sb, indent);
			if (i != expressions.length - 1)
				sb = sb.append(",");
		}
		sb = sb.append("}");
	}*/

	public boolean findDependency(BIdentifier bIdentifier) {
		for (int i = 0; i < expressions.length; i++) {
			if (expressions[i].findDependency(bIdentifier))
				return true;
		}
		return false;
	}

	public Expression cloneObject() { /* Verificar se OK ? */
		ExtensionSet extensionSetClone = new ExtensionSet();
		extensionSetClone.expressions = new Expression[expressions.length];
		for (int i = expressions.length - 1; i >= 0; i--) {
			extensionSetClone.expressions[i] = this.expressions[i]
					.cloneObject();
		}
		return extensionSetClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		BObject array[] = new BObject[expressions.length];
		for (int i = 0; i < expressions.length; i++)
			array[i] = expressions[i].substitute(dest, src);

		for (int i = 0; i < expressions.length; i++) {
			if (array[i] != expressions[i])
				break;
			else if (i == expressions.length - 1)
				return this;
		}
		ExtensionSet extensionSet = new ExtensionSet();
		extensionSet.setFields(array);
		return extensionSet;
	}*/

	public BObject acceptPOG(IBVisitorNodes pOG,
			BObject[] dest, Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public Expression[] getExpressions() {
		return expressions;
	}

	public void setExpressions(Expression[] expressions) {
		this.expressions = expressions;
	}

	public Expression getExpression(int i) {
		return expressions[i];
	}

	public void setExpressions(Expression expression, int i) {
		this.expressions[i] = expression;
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

}