package zb2smt.bol;

import zb2smt.IPOPrint;

public class FinitePowerSet extends SetFunction {
	Expression[] sets;

	public FinitePowerSet() {
	}

	public void setFields(BObject[] values) {
		sets = new Expression[values.length];
		for (int i = 0; i < values.length; i += 1) {
			sets[i] = ((Expression) values[i]);
		}
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<sets.length;i++){
			if(!sets[i].isFree(idents)){
				return false;
			}
		}
		return true;
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("FIN (");
		for (int i = 0; i < sets.length; i++) {
			sets[i].toBString(sb, indent);
			if (i != sets.length - 1)
				sb = sb.append(",");
		}
		sb = sb.append(")");
	}*/

	public boolean findDependency(BIdentifier arg0) {
		for (int i = 0; i < sets.length; i++) {
			if (sets[i].findDependency(arg0))
				return true;
		}
		return false;
	}

	public Expression cloneObject() { /* Verificar se OK ? */
		FinitePowerSet finitePowerSetClone = new FinitePowerSet();
		for (int i = 0; i < sets.length; i += 1) {
			finitePowerSetClone.sets[i] = this.sets[i].cloneObject();
		}
		return finitePowerSetClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		BObject array[] = new BObject[sets.length];
		for (int i = 0; i < sets.length; i++)
			array[i] = sets[i].substitute(dest, src); 
			// verificar a igualdade 
		for (int i = 0; i < sets.length; i++) {
			if (array[i] != sets[i])
				break;
			else if (i == sets.length - 1)
				return this;
		}
		FinitePowerSet finitePowerSet = new FinitePowerSet();
		finitePowerSet.setFields(array);
		return finitePowerSet;
	}*/

	public BObject acceptPOG(IBVisitorNodes pOG,
			BObject[] dest, Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb,
			String indent) {
		print.printFormat(this, sb, indent);
	}

	public Expression[] getSets() {
		return sets;
	}

	public void setSets(Expression[] sets) {
		this.sets = sets;
	}

	public Expression getSet(int i) {
		return sets[i];
	}

	public void setSets(Expression set, int i) {
		this.sets[i] = set;
	}
}