package zb2smt.bol;

import zb2smt.IPOPrint;

public class ForAll extends Predicate {
	BIdentifier[] identifiers;

	Implication implication;

	public ForAll() {
	}

	public void setFields(BObject[] values) {
		int i = 0;
		identifiers = new BIdentifier[values.length - 1];
		for (i = values.length - 2; i > -1; i -= 1) {
			identifiers[i] = (BIdentifier) values[i];
		}
		implication = (Implication) values[values.length - 1];
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<identifiers.length;i++){
			if(!identifiers[i].isFree(idents)){
				return false;
			}
		}
		return implication.isFree(idents);
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("ForAll ");
		for (int i = 0; i < identifiers.length; i++) {
			identifiers[i].toBString(sb, indent);
			if (i != identifiers.length - 1)
				sb = sb.append(",");
		}
		sb = sb.append(".(");
		implication.toBString(sb, indent);
		sb = sb.append(")");
	}*/

	public Predicate cloneObject() {
		ForAll forAllClone;
		BObject[] bObjectClone;
		int i;
		forAllClone = new ForAll();
		bObjectClone = new BObject[identifiers.length + 1];
		for (i = 0; i < bObjectClone.length - 1; i++) {
			bObjectClone[i] = identifiers[i].cloneObject();
		}
		bObjectClone[bObjectClone.length - 1] = implication.cloneObject();
		forAllClone.setFields(bObjectClone);
		return forAllClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		System.out
				.println("ForAll nao implementado o m�odo substitute(BIdentifier[] dest, Expression[] src) ");
		return this;
	}*/

	public BIdentifier[] getIdentifiers() {
		return identifiers;
	}

	public void setIdentifiers(BIdentifier[] identifiers) {
		this.identifiers = identifiers;
	}

	public Implication getImplication() {
		return implication;
	}

	public void setImplication(Implication implication) {
		this.implication = implication;
	}

	public BIdentifier getIdentifier(int i) {
		return identifiers[i];
	}

	public void setIdentifier(BIdentifier identifier, int i) {
		this.identifiers[i] = identifier;
	}

	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

}