package zb2smt.bol;

import zb2smt.IPOPrint;

public class GeneralizedIntersection extends SetExpression {
	Expression[] expressions;

	public GeneralizedIntersection() {
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public void setFields(BObject[] values) {
		expressions = new Expression[values.length];
		for (int i = 0; i < values.length; i += 1) {
			expressions[i] = ((Expression) values[i]);
		}
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<expressions.length;i++){
			if(!expressions[i].isFree(idents)){
				return false;
			}
		}
		return true;
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("inter (");
		for (int i = 0; i < expressions.length; i++) {
			expressions[i].toBString(sb, indent);
			if (i != expressions.length - 1)
				sb = sb.append(",");
		}
		sb = sb.append(")");
	}*/

	public boolean findDependency(BIdentifier bIdentifier) {
		for (int i = 0; i < expressions.length; i++) {
			if (expressions[i].findDependency(bIdentifier))
				return true;
		}
		return false;
	}

	public Expression cloneObject() { /* Verificar se OK ? */
		GeneralizedIntersection generalizedIntersectionClone = new GeneralizedIntersection();
		for (int i = expressions.length; i > 0; i--) {
			generalizedIntersectionClone.expressions[i] = this.expressions[i]
					.cloneObject();
		}
		return generalizedIntersectionClone;
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		BObject array[] = new BObject[expressions.length];
		for (int i = 0; i < expressions.length; i++)
			array[i] = expressions[i].substitute(dest, src); 
	// verificar a igualdade
		for (int i = 0; i < expressions.length; i++) {
			if (array[i] != expressions[i])
				break;
			else if (i == expressions.length - 1)
				return this;
		}
		GeneralizedIntersection generalizedIntersection = new GeneralizedIntersection();
		generalizedIntersection.setFields(array);
		return generalizedIntersection;
	}*/

	public Expression[] getExpressions() {
		return expressions;
	}

	public void setExpressions(Expression[] expressions) {
		this.expressions = expressions;
	}

	public Expression getExpression(int i) {
		return expressions[i];
	}

	public void setExpression(Expression expression, int i) {
		this.expressions[i] = expression;
	}
}