package zb2smt.bol;


public interface IBVisitorNodes {
	
	abstract public Predicate visitNode(Predicate inv, SetIn setIn);
	
	abstract public Predicate visitNode(Predicate inv, Let let);
	
	abstract public Predicate visitNode(Predicate inv, Any any);

	abstract public Predicate visitNode(Predicate inv, Select select);

	abstract public Predicate visitNode(Predicate inv, If if_);

	abstract public Predicate visitNode(Predicate inv, Choice choice);

	abstract public Predicate visitNode(Predicate inv, BecomeEqual becomeEqual);

	abstract public Predicate visitNode(Predicate inv, Skip skip);

	abstract public Predicate visitNode(Predicate inv, Begin begin);

	abstract public Predicate visitNode(Predicate inv, Precondition precondition);

	abstract public Predicate visitNode(Predicate inv, Sequencing sequencing);

	abstract public Predicate visitNode(Predicate inv, Parallel parallel);
	
	abstract public Predicate visitNode(Predicate inv, BecomeEqualFunction becomeEqualFunction);
	
	abstract public Predicate visitNode(Predicate inv, CallOperation callOperation);
	
	
	abstract public Predicate visitNode(Predicate inv, Assert assert1);	
	
	abstract public Predicate visitNode(Predicate inv, While while1);

	//abstract public Predicate toSubstitute(Predicate inv, When when);


	/* Metodos Substitute Tratados */
	
	abstract public BObject visitNode(SetIn setIn, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Let let, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Any any, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Select select, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(If if_, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(ElseIf elseIf, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Choice choice, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(BecomeEqual becomeEqual, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Skip skip, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Begin begin, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Precondition precondition, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Sequencing sequencing, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Parallel parallel, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(BecomeEqualFunction becomeEqualFunction, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(And and, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(BBoolean bBoolean, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(BIdentifier bIdentifier, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(BInteger bInteger, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(BooleanExpression booleanExpression, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(BooleanSet booleanSet, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Card card, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Division division, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(EmptySet emptySet, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Equal equal, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(EqualBoolean equalBoolean, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(EqualEnumerated equalEnumerated, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(EqualSet equalSet, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Equivalence equivalence, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(FinitePowerSet finitePowerSet, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(ForAll forAll, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(GreatherThan greatherThan, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(GreatherThanOrEqual greatherThanOrEqual, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Implication implication, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(In in, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(IntegerSet integerSet, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Intersection intersection, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Interval interval, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(LessThan lessThan, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(LessThanOrEqual lessThanOrEqual, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Minus minus, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Modulo modulo, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Not not, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(NotEqual notEqual, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(NotEqualBoolean notEqualBoolean, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(NotEqualEnumerated notEqualEnumerated, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(NotEqualSet notEqualSet, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(NotSetMemberShip notSetMemberShip, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(NotStrictSubset notStrictSubset, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(NotSubset notSubset, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Or or, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Plus plus, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(PowerSet powerSet, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Product product, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(NonEmptySubsets nonEmptySubsets, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Results results, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(StrictSubset strictSubset, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(StringSet stringSet, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Subset subset, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(UnaryMinus unaryMinus, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Union union, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(EqualOrderedPair equalOrderedPair, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(EqualSequence equalSequence, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(Exists exists, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(NotEqualOrderedPair notEqualOrderedPair, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(NotEqualSequence notEqualSequence, BObject[] dest, Expression[] src);
	abstract public BObject visitNode(ExtensionSet extensionSet, BObject[] dest, Expression[] src);

	
	/* Metodos Substitute N�O Tratados */
	
	//
	
	abstract public BObject visitNode(CompareArithmeticExpression cmpAritExpression, BObject[] dest, Expression[] src);

	abstract public BObject visitNode(CompareBooleanExpression cmpBooleanExpression, BObject[] dest, Expression[] src);

	abstract public BObject visitNode(ArithmeticFunction ariFunction, BObject[] dest, Expression[] src);

	abstract public BObject visitNode(OrderedPair ordPair, BObject[] dest, Expression[] src);
	
	
	abstract public BObject visitNode(Append append, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(ArrayElement arrayElement, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(BEnumeratedValue bEnumeratedValue, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(BPreviousValue bPreviousValue, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(BString bString, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(CallFunction callFunction, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(CallOperation callOperation, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Closure closure, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Closure1 closure1, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(ComprehensionSet comprehensionSet, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Concatenate concatenate, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Domain domain, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(DomainSubstraction domainSubstraction, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(EmptySequence emptySequence, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(ExtensionSequence extensionSequence, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(First first, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Fnc fnc, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Front front, BObject[] dest, Expression[] src);

	abstract public BObject visitNode(GeneralizedConcatenation generalizedConcatenation, BObject[] dest, Expression[] src);

	abstract public BObject visitNode(GeneralizedIntersection generalizedIntersection, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(GeneralizedUnion generalizedUnion, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Identity identity, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(IntegerValue integerValue, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Inverse inverse, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(ISeq iSeq, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(ISeq1 iSeq1, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Iterate iterate, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Lambda lambda, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Last last, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Max max, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Min min, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(NonEmptyFiniteSubsets nonEmptyFiniteSubsets, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Permutation permutation, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Pi pi, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Prefix prefix, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Prepend prepend, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Projection1 projection1, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Projection2 projection2, BObject[] dest, Expression[] src);

	abstract public BObject visitNode(QuantifiedIntersection quantifiedIntersection, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(QuantifiedUnion quantifiedUnion, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Range range, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Rel rel, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Reverse reverse, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Seq seq, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Seq1 seq1, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Sigma sigma, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Size size, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Suffix suffix, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Tail tail, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(DirectProduct directProduct, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(CartesianProduct cartesianProdct, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(DomainRestriction domainRestriction, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Image image, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Composition composition, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Overriding overriding, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(ParallelProduct parallelProduct, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(PartialBijection partialBijection, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(PartialFunction partialFunction, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(PartialInjection partialFunction, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(PartialSurjection partialSurjection, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(Power power, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode(RangeRestriction rangeRestriction, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode( RangeSubstraction rangeSubstraction, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode( Relation relation, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode( SetMinus setMinus, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode( TotalBijection totalBijection, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode( TotalFunction totalFunction, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode( TotalInjection totalInjection, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode( TotalSurjection totalSurjection, BObject[] dest, Expression[] src);
	
	abstract public BObject visitNode( LetDefinition letDefinition, BObject[] dest, Expression[] src);
	
	/*
	 * Criados
	 */
	public abstract BObject visitNode(PredicateExpression expression, BObject[] dest, Expression[] src);
}