package zb2smt.bol;


public class If extends Substitution {
	Predicate predicate;

	Substitution then;

	ElseIf[] elseIfs;

	Substitution elseSubstitution;

	public If() {
	}

	public void setFields(BObject[] values) {
		int bsup;
		predicate = (Predicate) values[0];
		then = (Substitution) values[1];
		if (values.length > 2) {
			if (values[values.length - 1] instanceof Substitution) {
				elseSubstitution = (Substitution) values[values.length - 1];
				bsup = values.length - 1;
			} else {
				bsup = values.length;
			}
			if (bsup > 2) {
				elseIfs = new ElseIf[bsup - 2];
				for (int i = 2; i < bsup; i += 1) {
					elseIfs[i - 2] = ((ElseIf) values[i]);
				}
			}
		}
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<elseIfs.length;i++){
			if(!elseIfs[i].isFree(idents)){
				return false;
			}
		}
		return predicate.isFree(idents) && then.isFree(idents) && elseSubstitution.isFree(idents);
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent + "IF\n");
		predicate.toBString(sb, indent.concat("  "));
		sb = sb.append("\n" + indent + "THEN\n");
		then.toBString(sb, indent.concat("  "));
		sb = sb.append("\n");
		if (elseIfs != null) {
			for (int i = 0; i < elseIfs.length; i++) {
				elseIfs[i].toBString(sb, indent);
				sb = sb.append("\n");
			}
		}
		if (elseSubstitution != null) {
			sb = sb.append(indent + "ESLE\n");
			elseSubstitution.toBString(sb, indent.concat("  "));
		}
		sb = sb.append("\n" + indent + "END");
	}*/

	public Predicate acceptPOGSubstitution(IBVisitorNodes pOG, Predicate inv) {
		return pOG.visitNode(inv, this);
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public ElseIf[] getElseIfs() {
		return elseIfs;
	}

	public void setElseIfs(ElseIf[] elseIfs) {
		this.elseIfs = elseIfs;
	}

	public Substitution getElseSubstitution() {
		return elseSubstitution;
	}

	public void setElseSubstitution(Substitution elseSubstitution) {
		this.elseSubstitution = elseSubstitution;
	}

	public Predicate getPredicate() {
		return predicate;
	}

	public void setPredicate(Predicate predicate) {
		this.predicate = predicate;
	}

	public Substitution getThen() {
		return then;
	}

	public void setThen(Substitution then) {
		this.then = then;
	}

	public ElseIf getElseIf(int i) {
		return elseIfs[i];
	}

	public void setElseIf(ElseIf elseIf, int i) {
		this.elseIfs[i] = elseIf;
	}
}