package zb2smt.bol;

import zb2smt.IPOPrint;

public class Interval extends SetExpression {
	Expression left;

	Expression right;

	public Interval() {
	}

	public void setFields(BObject[] values) {
		left = (Expression) values[0];
		right = (Expression) values[1];
	}

	public boolean isFree(BIdentifier[] idents){
		return left.isFree(idents) && right.isFree(idents);
	}
	
	/*public void toBString(StringBuffer sb, String indent) {
		left.toBString(sb, indent);
		sb = sb.append("..");
		right.toBString(sb, indent);
	}*/

	public boolean findDependency(BIdentifier bIdentifier) {
		return left.findDependency(bIdentifier)
				|| right.findDependency(bIdentifier);
	}

	public Expression cloneObject() { /* Verificar se OK ? */
		Interval intervalClone = new Interval();
		intervalClone.left = this.left.cloneObject();
		intervalClone.right = this.right.cloneObject();
		return intervalClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		BObject[] array = new BObject[2];
		array[0] = this.left.substitute(dest, src);
		array[1] = this.right.substitute(dest, src);
		if ((array[0] == this.left) && (array[1] == this.right))
			return this;
		Interval interval = new Interval();
		interval.setFields(array);
		return interval;
	}*/

	public BObject acceptPOG(IBVisitorNodes pOG,
			BObject[] dest, Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb,
			String indent) {
		print.printFormat(this, sb, indent);
	}

	public Expression getLeft() {
		return left;
	}

	public void setLeft(Expression left) {
		this.left = left;
	}

	public Expression getRight() {
		return right;
	}

	public void setRight(Expression right) {
		this.right = right;
	}
}