package zb2smt.bol;


public class Let extends Substitution {
	BIdentifier[] identifiers;

	LetDefinition[] lets;

	Substitution substitution;

	public Let() {
	}

	public void setFields(BObject[] values) {
		int moitie = (values.length - 1) / 2;
		int i, j;
		identifiers = new BIdentifier[moitie];
		lets = new LetDefinition[moitie];
		for (i = 0; i < moitie; i += 1) {
			identifiers[i] = (BIdentifier) values[i];
		}
		for (j = 0; j < moitie; j += 1, i += 1) {
			lets[j] = (LetDefinition) values[i];
		}
		substitution = (Substitution) values[values.length - 1];
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<identifiers.length;i++){
			if(!identifiers[i].isFree(idents)){
				return false;
			}
		}
		for(int i=0;i<lets.length;i++){
			if(!lets[i].isFree(idents)){
				return false;
			}
		}
		return substitution.isFree(idents);
	}
	
	public Predicate acceptPOGSubstitution(IBVisitorNodes pOG, Predicate inv) {
		return pOG.visitNode(inv, this);
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent + "LET ");
		for (int i = 0; i < identifiers.length; i++) {
			identifiers[i].toBString(sb, indent);
			if (i != identifiers.length - 1)
				sb = sb.append(",");
		}
		sb = sb.append("\n" + indent + "BE\n");
		for (int i = 0; i < lets.length; i++) {
			lets[i].toBString(sb, indent.concat("  "));
			if (i != lets.length - 1)
				sb = sb.append(" &\n");
		}
		sb = sb.append("\n" + indent + "IN\n");
		substitution.toBString(sb, indent.concat("  "));
		sb = sb.append("\n" + indent + "END\n");
	}*/

	public BIdentifier[] getIdentifiers() {
		return identifiers;
	}

	public void setIdentifiers(BIdentifier[] identifiers) {
		this.identifiers = identifiers;
	}

	public LetDefinition[] getLets() {
		return lets;
	}

	public void setLets(LetDefinition[] lets) {
		this.lets = lets;
	}

	public Substitution getSubstitution() {
		return substitution;
	}

	public void setSubstitution(Substitution substitution) {
		this.substitution = substitution;
	}
}