package zb2smt.bol;

import zb2smt.IPOPrint;

public class NonEmptySubsets extends SetFunction {
	Expression[] sets;

	public NonEmptySubsets() {
	}

	public void setFields(BObject[] values) {
		sets = new Expression[values.length];
		for (int i = 0; i < values.length; i += 1) {
			sets[i] = ((Expression) values[i]);
		}
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<sets.length;i++){
			if(!sets[i].isFree(idents)){
				return false;
			}
		}
		return true;
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
/*	public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("POW1 (");
		for (int i = 0; i < sets.length; i++) {
			sets[i].toBString(sb, indent);
			if (i != sets.length - 1)
				sb = sb.append(",");
		}
		sb = sb.append(")");
	}*/

	public boolean findDependency(BIdentifier arg0) {
		for (int i = 0; i < sets.length; i++) {
			if (sets[i].findDependency(arg0))
				return true;
		}
		return false;
	}

	public Expression cloneObject() {
		NonEmptySubsets nonEmptySubsetsClone = new NonEmptySubsets();
		for (int i = 0; i < sets.length; i += 1) {
			nonEmptySubsetsClone.sets[i] = this.sets[i].cloneObject();
		}
		return nonEmptySubsetsClone;
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		BObject array[] = new BObject[sets.length];
		for (int i = 0; i < sets.length; i++)
			array[i] = sets[i].substitute(dest, src);
		for (int i = 0; i < sets.length; i++) {
			if (array[i] != sets[i])
				break;
			else if (i == sets.length - 1)
				return this;
		}
		NonEmptySubsets nonEmptySubsets = new NonEmptySubsets();
		nonEmptySubsets.setFields(array);
		return nonEmptySubsets;
	}*/ 
	
	public Expression[] getSets() {
		return sets;
	}

	public void setSets(Expression[] sets) {
		this.sets = sets;
	}

	public Expression getSet(int i) {
		return sets[i];
	}

	public void setSets(Expression set, int i) {
		this.sets[i] = set;
	}
}