package zb2smt.bol;

import zb2smt.IPOPrint;

public class Or extends Predicate {
	Predicate[] predicates;

	public Or() {
	}

	public void setFields(BObject[] values) {
		predicates = new Predicate[values.length];
		for (int i = 0; i < values.length; i += 1) {
			predicates[i] = ((Predicate) values[i]);
		}
	}

	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<predicates.length;i++){
			if(!predicates[i].isFree(idents)){
				return false;
			}
		}
		return true;
	}
	
/*	public void toBString(StringBuffer sb, String indent) {
		sb.append("(");
		for (int i = 0; i < predicates.length; i++) {
			sb = sb.append(indent);
			predicates[i].toBString(sb, indent);
			if (i != predicates.length - 1)
				sb = sb.append(" or ");
		}
		sb.append(")");
	}*/

	public Predicate cloneObject() {
		Or orClone;
		BObject[] bObjectClone;
		int i;
		orClone = new Or();
		bObjectClone = new BObject[predicates.length];
		for (i = 0; i < bObjectClone.length; i++) {
			bObjectClone[i] = predicates[i].cloneObject();
		}
		orClone.setFields(bObjectClone);
		return orClone;
	}

/*	public BObject substitute(BIdentifier[] dest, Expression[] src) {
		boolean thereare_change = false;
		BObject[] b = new BObject[predicates.length];
		for (int i = 0; i < predicates.length; i++) {
			b[i] = this.predicates[i].substitute(dest, src);
			if (b[i] != this.predicates[i])
				thereare_change = true;
		}
		if (!thereare_change)
			return this;
		else {
			Or a = new Or();
			a.setFields(b);
			return a;
		}
	}*/

	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

	public Predicate[] getPredicates() {
		return predicates;
	}

	public void setPredicates(Predicate[] predicates) {
		this.predicates = predicates;
	}

	public Predicate getPredicate(int i) {
		return predicates[i];
	}

	public void setPredicate(Predicate predicate, int i) {
		this.predicates[i] = predicate;
	}
}
