package zb2smt.bol;

import zb2smt.IPOPrint;

public class OrderedPair extends BBaseElement {
	Expression left;

	Expression right;

	public OrderedPair() {
	}

	public void setFields(BObject[] values) {
		left = (Expression) values[0];
		right = (Expression) values[1];
	}
	
	public boolean isFree(BIdentifier[] idents){
		return left.isFree(idents) && right.isFree(idents);
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
/*	public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("(");
		left.toBString(sb, indent);
		sb = sb.append("|->");
		right.toBString(sb, indent);
		sb = sb.append(")");
	}*/

	public boolean findDependency(BIdentifier arg0) {
		return left.findDependency(arg0) || right.findDependency(arg0);
	}

	public Expression cloneObject() {
		OrderedPair orderedPairClone;
		orderedPairClone = new OrderedPair();
		orderedPairClone.left = left.cloneObject();
		orderedPairClone.right = right.cloneObject();
		return orderedPairClone;
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		OrderedPair orderedPairClone = null;
		Expression left = (Expression) this.left.substitute(dest, src);
		Expression right = (Expression) this.right.substitute(dest, src);
		if (left != this.left || right != this.right) {
			orderedPairClone = new OrderedPair();
			orderedPairClone.left = left;
			orderedPairClone.right = right;
			return orderedPairClone;
		} else {
			return this;
		}
	}*/

	/*public BObject acceptPOGPredicate(IPOGenerator pOG,
			BIdentifier[] dest, Expression[] src) {
		return pOG.substitute(this, dest, src);
	}*/

	/*public void acceptPrint(IPOPrint print, StringBuffer sb,
			String indent) {
		print.printFormat(this, sb, indent);
	}*/

	public Expression getLeft() {
		return left;
	}

	public void setLeft(Expression left) {
		this.left = left;
	}

	public Expression getRight() {
		return right;
	}

	public void setRight(Expression right) {
		this.right = right;
	}
}