package zb2smt.bol;


public class Parallel extends Substitution {
	Substitution[] substitutions;

	public Parallel() {
	}

	public void setFields(BObject[] values) {
		substitutions = new Substitution[values.length];
		for (int i = 0; i < values.length; i += 1) {
			substitutions[i] = ((Substitution) values[i]);
		}
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<substitutions.length;i++){
			if(!substitutions[i].isFree(idents)){
				return false;
			}
		}
		return true;
	}

/*	public void toBString(StringBuffer sb, String indent) {
		for (int i = 0; i < substitutions.length; i++) {
			substitutions[i].toBString(sb, indent);
			if (i != substitutions.length - 1)
				sb = sb.append("||\n");
		}
	}*/

	public Predicate acceptPOGSubstitution(IBVisitorNodes pOG, Predicate inv) {
		return pOG.visitNode(inv, this);
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest, Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public Substitution[] getSubstitutions() {
		return substitutions;
	}

	public void setSubstitutions(Substitution[] substitutions) {
		this.substitutions = substitutions;
	}

	public Substitution getSubstitution(int i) {
		return substitutions[i];
	}

	public void setSubstitution(Substitution substitution, int i) {
		this.substitutions[i] = substitution;
	}
}