package zb2smt.bol;

import zb2smt.IPOPrint;

public class Pi extends ArithmeticExpression {
	BIdentifier[] identifiers;

	Predicate predicate;

	Expression expression;

	public Pi() {
	}

	public void setFields(BObject[] values) {
		int i = 0;
		identifiers = new BIdentifier[values.length - 2];
		for (i = values.length - 3; i > -1; i -= 1) {
			identifiers[i] = (BIdentifier) values[i];
		}
		predicate = (Predicate) values[values.length - 2];
		expression = (Expression) values[values.length - 1];
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<identifiers.length;i++){
			if(!identifiers[i].isFree(idents)){
				return false;
			}
		}
		return predicate.isFree(idents) &&  expression.isFree(idents);
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	public boolean findDependency(BIdentifier bIdentifier) {
		for(int i=0;i<identifiers.length;i++){
			if(identifiers[i].findDependency(bIdentifier))
				return true;
		}
		
		if(expression.findDependency(bIdentifier))
			return true;
		
		return false;
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("PI ");
		for (int i = 0; i < identifiers.length; i++) {
			identifiers[i].toBString(sb, indent);
			if (i != identifiers.length)
				sb = sb.append(",");
		}
		sb = sb.append(".(");
		predicate.toBString(sb, indent);
		sb = sb.append(" | ");
		expression.toBString(sb, indent);
		sb = sb.append(")");
	}*/
	
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

	/*public boolean findDependency(BIdentifier bIdentifier) {
		System.out
				.println("O metodo findDependency ainda nao esta implementado para estah expressao");
		return false;
	}*/

	public Expression cloneObject() {
		Pi piClone;
		BObject[] bObject;
		piClone = new Pi();
		bObject = new BObject[identifiers.length + 2];
		for (int i = 0; i < identifiers.length; i++) {
			bObject[i] = identifiers[i].cloneObject();
		}
		bObject[bObject.length - 2] = predicate.cloneObject();
		bObject[bObject.length - 1] = expression.cloneObject();
		piClone.setFields(bObject);
		return piClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		System.out
				.println("Pi nao implementado para o m�odo substitute(BIdentifier[] dest, Expression[] src) ");
		return this.cloneObject();
	}*/

	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}

	public BIdentifier[] getIdentifiers() {
		return identifiers;
	}

	public void setIdentifiers(BIdentifier[] identifiers) {
		this.identifiers = identifiers;
	}

	public Predicate getPredicate() {
		return predicate;
	}

	public void setPredicate(Predicate predicate) {
		this.predicate = predicate;
	}

	public BIdentifier getIdentifier(int i) {
		return identifiers[i];
	}

	public void setIdentifiers(BIdentifier identifier, int i) {
		this.identifiers[i] = identifier;
	}

}