package zb2smt.bol;

import zb2smt.IPOPrint;

/**
 * Classe inserido na gramatica de Bol para representar
 * termos de expressoes isoladas em gramaticas como TRUE, p e q 
 * em p \land q .
 * @author alessandro87
 *
 */
public class PredicateExpression extends Predicate{

	Expression expression;

	public PredicateExpression(Expression expression) {
		super();
		this.expression = expression;
	}

	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest, Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);

	}

	public Predicate cloneObject() {
		PredicateExpression predExprClone;
		Expression exprClone = expression.cloneObject();
		predExprClone = new PredicateExpression(exprClone);
		return predExprClone;
	}

	public boolean isFree(BIdentifier[] idents) {
		if (!expression.isFree(idents)){
			return false;
		}
		return true;
	}

	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}

}
