package zb2smt.bol;

import zb2smt.IPOPrint;

public class Prefix extends SequenceExpression {
	Expression left;

	Expression right;

	public Prefix() {
	}

	public void setFields(BObject[] values) {
		left = (Expression) values[0];
		right = (Expression) values[1];
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	
	public boolean isFree(BIdentifier[] idents){
		return left.isFree(idents) && right.isFree(idents);
	}
	/*public void toBString(StringBuffer sb, String indent) {
		left.toBString(sb, indent);
		sb = sb.append("->");
		right.toBString(sb, indent);
	}*/

	public boolean findDependency(BIdentifier bIdentifier) {
		return left.findDependency(bIdentifier)
				|| right.findDependency(bIdentifier);
	}

	public Expression cloneObject() {
		Prefix prefixClone;
		prefixClone = new Prefix();
		prefixClone.left = left.cloneObject();
		prefixClone.right = right.cloneObject();
		return prefixClone;
	}
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		Prefix prefixClone;
		Expression left = (Expression) this.left.substitute(dest, src);
		Expression right = (Expression) this.right.substitute(dest, src);
		if (left != this.left || right != this.right) {
			prefixClone = new Prefix();
			prefixClone.left = left;
			prefixClone.right = right;
			return prefixClone;
		} else {
			return this;
		}
	}*/
	
	public Expression getLeft() {
		return left;
	}

	public void setLeft(Expression left) {
		this.left = left;
	}

	public Expression getRight() {
		return right;
	}

	public void setRight(Expression right) {
		this.right = right;
	}
}