package zb2smt.bol;

import zb2smt.IPOPrint;

public class Prepend extends SequenceExpression {
	Expression left;

	BBaseElement right;

	public Prepend() {
	}

	public void setFields(BObject[] values) {
		left = (Expression) values[0];
		right = (BBaseElement) values[1];
	}
	
	public boolean isFree(BIdentifier[] idents){
		return left.isFree(idents) && right.isFree(idents);
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
/*	public void toBString(StringBuffer sb, String indent) {
		left.toBString(sb, indent);
		sb = sb.append("/|\\");
		right.toBString(sb, indent);
	}*/

	public boolean findDependency(BIdentifier bIdentifier) {
		return left.findDependency(bIdentifier)
				|| right.findDependency(bIdentifier);
	}

	public Expression cloneObject() {
		Prepend prependClone;
		prependClone = new Prepend();
		prependClone.left = left.cloneObject();
		prependClone.right = (BBaseElement) right.cloneObject();
		return prependClone;
	}

	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}
	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		Prepend prependClone;
		Expression left = (Expression) this.left.substitute(dest, src);
		BBaseElement right = (BBaseElement) this.right.substitute(dest, src);
		if (left != this.left || right != this.right) {
			prependClone = new Prepend();
			prependClone.left = left;
			prependClone.right = right;
			return prependClone;
		} else {
			return this;
		}
	}*/
	
	public Expression getLeft() {
		return left;
	}

	public void setLeft(Expression left) {
		this.left = left;
	}

	public BBaseElement getRight() {
		return right;
	}

	public void setRight(BBaseElement right) {
		this.right = right;
	}
}