package zb2smt.bol;

import zb2smt.IPOPrint;

public class Projection1 extends SetFunction {
	Expression set1;
	Expression set2;

	public Projection1() {
	}

	public void setFields(BObject[] values) {
		set1 = (Expression) values[0];
		set2 = (Expression) values[1];
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	
	public boolean isFree(BIdentifier[] idents){
		return set1.isFree(idents) && set2.isFree(idents);
	}
	
	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("prj1 (");
		set1.toBString(sb, indent);
		sb = sb.append(",");
		set2.toBString(sb, indent);
		sb = sb.append(")");
	}*/

	public boolean findDependency(BIdentifier arg0) {
		return set1.findDependency(arg0) || set2.findDependency(arg0);
	}

	public Expression cloneObject() {
		Projection1 projection1Clone = new Projection1();
		projection1Clone.set1 = this.set1.cloneObject();
		projection1Clone.set2 = this.set2.cloneObject();
		return projection1Clone;
	}
	
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		Expression s1 = (Expression) this.set1.substitute(dest, src);
		Expression s2 = (Expression) this.set2.substitute(dest, src);
		if (s1 == this.set1 && s2 == this.set2)
			return this;
		Projection1 projection1Clone = new Projection1();
		projection1Clone.set1 = s1;
		projection1Clone.set2 = s2;
		return projection1Clone;
	}*/ 
	
	public Expression getSet1() {
		return set1;
	}

	public void setSet1(Expression set1) {
		this.set1 = set1;
	}

	public Expression getSet2() {
		return set2;
	}

	public void setSet2(Expression set2) {
		this.set2 = set2;
	}
}