package zb2smt.bol;

import zb2smt.IPOPrint;

public class QuantifiedUnion extends SetExpression {
	BIdentifier[] identifiers;

	Predicate predicate;

	Expression expression;

	public QuantifiedUnion() {
	}
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<identifiers.length;i++){
			if(!identifiers[i].isFree(idents)){
				return false;
			}
		}
		return predicate.isFree(idents) &&  expression.isFree(idents);
	}
	
	public void setFields(BObject[] values) {
		int i = 0;
		identifiers = new BIdentifier[values.length - 2];
		for (i = values.length - 3; i > -1; i -= 1) {
			identifiers[i] = (BIdentifier) values[i];
		}
		predicate = (Predicate) values[values.length - 2];
		expression = (Expression) values[values.length - 1];
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append("UNION ");
		for (int i = 0; i < identifiers.length; i++) {
			identifiers[i].toBString(sb, indent);
			if (i != identifiers.length - 1)
				sb = sb.append(",");
		}
		sb = sb.append(".(");
		predicate.toBString(sb, indent);
		sb = sb.append(" | ");
		expression.toBString(sb, indent);
		sb = sb.append(")");
	}*/

	public boolean findDependency(BIdentifier bIdentifier) {
		for(int i=0;i<identifiers.length;i++){
			if(identifiers[i].findDependency(bIdentifier))
				return true;
		}
		return false;
	}

	public Expression cloneObject() { /* Verificar se OK ? */
		QuantifiedUnion quantifiedUnionClone = new QuantifiedUnion();
		for (int i = identifiers.length; i > 0; i--) {
			quantifiedUnionClone.identifiers[i] = (BIdentifier) this.identifiers[i]
					.cloneObject();
		}
		quantifiedUnionClone.predicate = this.predicate.cloneObject();
		quantifiedUnionClone.expression = this.expression.cloneObject();
		return quantifiedUnionClone;
	}

	/*public BObject substitute(BIdentifier[] dest, Expression[] src) {
		System.out.println("N� tratado o:QuantifiedUnion");
		return this.cloneObject();
	}*/ 
	
	public void acceptPrint(IPOPrint print, StringBuffer sb, String indent) {
		print.printFormat(this, sb, indent);
	}

	public Expression getExpression() {
		return expression;
	}

	public void setExpression(Expression expression) {
		this.expression = expression;
	}

	public BIdentifier[] getIdentifiers() {
		return identifiers;
	}

	public void setIdentifiers(BIdentifier[] identifiers) {
		this.identifiers = identifiers;
	}

	public Predicate getPredicate() {
		return predicate;
	}

	public void setPredicate(Predicate predicate) {
		this.predicate = predicate;
	}

	public BIdentifier getIdentifier(int i) {
		return identifiers[i];
	}

	public void setIdentifiers(BIdentifier identifier, int i) {
		this.identifiers[i] = identifier;
	}
}