package zb2smt.bol;


public class Select extends Substitution {
	Predicate predicate;

	Substitution then;

	When[] whens;

	Substitution elseSubstitution;

	public Select() {
	}

	public void setFields(BObject[] values) {
		int bsup;
		predicate = (Predicate) values[0];
		then = (Substitution) values[1];
		if (values.length > 2) {
			if (values[values.length - 1] instanceof Substitution) {
				elseSubstitution = (Substitution) values[values.length - 1];
				bsup = values.length - 1;
			} else {
				bsup = values.length;
			}
			if (bsup > 2) {
				whens = new When[bsup - 2];
				for (int i = 2; i < bsup; i += 1) {
					whens[i - 2] = ((When) values[i]);
				}
			}
		}
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<whens.length;i++){
			if(!whens[i].isFree(idents)){
				return false;
			}
		}
		return predicate.isFree(idents) &&  then.isFree(idents) && elseSubstitution.isFree(idents);
	}

	/*public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent + "SELECT ");
		predicate.toBString(sb, indent);
		sb = sb.append(indent + " THEN\n");
		then.toBString(sb, indent);
		if (whens != null) {
			for (int i = 0; i < whens.length; i++) {
				whens[i].toBString(sb, indent.concat("  "));
				sb = sb.append(indent + "\n");
			}
		}
		if (elseSubstitution != null) {
			sb = sb.append(indent + "ELSE\n");
			elseSubstitution.toBString(sb, indent.concat("  "));
		}
		sb = sb.append(indent + "END");
	}*/

	public Predicate acceptPOGSubstitution(IBVisitorNodes pOG, Predicate inv) {
		return pOG.visitNode(inv, this);
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest, Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	
	public Substitution getElseSubstitution() {
		return elseSubstitution;
	}

	public void setElseSubstitution(Substitution elseSubstitution) {
		this.elseSubstitution = elseSubstitution;
	}

	public Predicate getPredicate() {
		return predicate;
	}

	public void setPredicate(Predicate predicate) {
		this.predicate = predicate;
	}

	public Substitution getThen() {
		return then;
	}

	public void setThen(Substitution then) {
		this.then = then;
	}

	public When[] getWhens() {
		return whens;
	}

	public void setWhens(When[] whens) {
		this.whens = whens;
	}

	public When getWhen(int i) {
		return whens[i];
	}

	public void setWhen(When whens, int i) {
		this.whens[i] = whens;
	}
}