package zb2smt.bol;


public class SetIn extends Substitution {
	BIdentifier[] identifiers;

	Expression set;

	public void setFields(BObject[] values) {
		int i = 0;
		identifiers = new BIdentifier[values.length - 1];
		for (i = values.length - 2; i > -1; i -= 1) {
			identifiers[i] = (BIdentifier) values[i];
		}
		set = (Expression) values[values.length - 1];
	}

	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<identifiers.length;i++){
			if(!identifiers[i].isFree(idents)){
				return false;
			}
		}
		return set.isFree(idents);
	}
	
	public Predicate acceptPOGSubstitution(IBVisitorNodes pOG, Predicate inv) {
		return pOG.visitNode(inv, this);
	}
	
	public BObject acceptPOG(IBVisitorNodes pOG, BObject[] dest,
			Expression[] src) {
		return pOG.visitNode(this, dest, src);
	}
	
/*	public void toBString(StringBuffer sb, String indent) {
		sb = sb.append(indent);
		for (int i = 0; i < identifiers.length; i++) {
			identifiers[i].toBString(sb, indent);
			if (i != identifiers.length - 1)
				sb = sb.append(",");
		}
		sb = sb.append(" :: ");
		set.toBString(sb, indent);
	}*/

	public BIdentifier[] getIdentifiers() {
		return identifiers;
	}

	public void setIdentifiers(BIdentifier[] identifiers) {
		this.identifiers = identifiers;
	}

	public Expression getSet() {
		return set;
	}

	public void setSet(Expression set) {
		this.set = set;
	}
}