package zb2smt.bol;

public abstract class SetPredicate extends Predicate {
	Expression[] expressions;

	Expression set;

	public void setFields(BObject[] values) {
		int i = 0;
		expressions = new Expression[values.length - 1];
		for (i = values.length - 2; i > -1; i -= 1) {
			expressions[i] = (Expression) values[i];
		}
		set = (Expression) values[values.length - 1];
	}
	
	public boolean isFree(BIdentifier[] idents){
		for(int i=0;i<expressions.length;i++){
			if(!expressions[i].isFree(idents)){
				return false;
			}
		}
		return set.isFree(idents);
	}

/*	public BObject substitute(BIdentifier[] identifiers, Expression[] exps) {
		int i;
		SetPredicate setpredicate = null;

		BObject[] array = new BObject[expressions.length + 1];

		for (i = 0; i < expressions.length; i++) {
			array[i] = expressions[i].substitute(identifiers, exps);
		}
		array[array.length - 1] = set.substitute(identifiers, exps);
		// verifica a a igualdade entre os vetores array[i] e
		// this.expressions[i]
		for (i = 0; i < array.length; i++) {
			if (i < array.length - 1) {
				if (array[i] != this.expressions[i])
					break;
			} else if ((i == array.length - 1)
					&& (this.set == array[array.length - 1])) {
				return this;
			}
		}

		if (this instanceof In) {
			setpredicate = new In();
		} else if (this instanceof NotSetMemberShip) {
			setpredicate = new NotSetMemberShip();
		} else if (this instanceof Subset) {
			setpredicate = new Subset();
		} else if (this instanceof NotSubset) {
			setpredicate = new NotSubset();
		} else if (this instanceof StrictSubset) {
			// System.out.println("StrictSubset");
			setpredicate = new StrictSubset();
		} else if (this instanceof NotStrictSubset) {
			setpredicate = new NotStrictSubset();
		}

		setpredicate.setFields(array);

		return setpredicate;

	}*/

	public Predicate cloneObject() {

		Expression[] expressionsClone;
		SetPredicate setpredicate = null;
		int i;

		if (this instanceof In) {
			setpredicate = new In();
		} else if (this instanceof NotSetMemberShip) {
			setpredicate = new NotSetMemberShip();
		} else if (this instanceof Subset) {
			setpredicate = new Subset();
		} else if (this instanceof StrictSubset) {
			setpredicate = new StrictSubset();
		} else if (this instanceof NotStrictSubset) {
			setpredicate = new NotStrictSubset();
		}

		expressionsClone = new Expression[expressions.length + 1];

		for (i = 0; i < expressions.length; i++) {
			expressionsClone[i] = expressions[i].cloneObject();
		}

		expressionsClone[expressionsClone.length - 1] = set.cloneObject();

		setpredicate.setFields(expressionsClone);

		// System.out.println("In");

		return setpredicate;

	}

	public Expression[] getExpressions() {
		return expressions;
	}

	public void setExpressions(Expression[] expressions) {
		this.expressions = expressions;
	}

	public Expression getSet() {
		return set;
	}

	public void setSet(Expression set) {
		this.set = set;
	}

	public Expression getExpression(int i) {
		return expressions[i];
	}

	public void setExpression(Expression expression, int i) {
		this.expressions[i] = expression;
	}
}