package zb2smt.convertZ2B;

import java.util.LinkedList;

import javax.swing.JOptionPane;

import zb2smt.bol.BIdentifier;
import zb2smt.bol.Expression;
import zb2smt.bol.Predicate;

import net.sourceforge.czt.base.ast.Term;
import net.sourceforge.czt.base.visitor.TermVisitor;
import net.sourceforge.czt.z.ast.Expr;
import net.sourceforge.czt.z.ast.Pred;

public class ConvertCircus2Bol  implements TermVisitor{

	private ConvertCircus2BolExpr exprConversor;
	private ConvertCircus2BolPred predConversor;
	private StringBuffer percurso;
	
	private LinkedList<BIdentifier> identificadores;
	
	public ConvertCircus2Bol(){
		exprConversor = new ConvertCircus2BolExpr(this);
		predConversor = new ConvertCircus2BolPred(this);
		percurso = new StringBuffer();
		identificadores = new LinkedList<BIdentifier>();
	}
	
	public ConvertCircus2BolExpr getExprConversor() {
		return exprConversor;
	}
	public ConvertCircus2BolPred getPredConversor() {
		return predConversor;
	}
	

	public StringBuffer getPercurso() {
		return percurso;
	}

	public Object visitTerm(Term term) {
		percurso = new StringBuffer(); // reinicia o percurso
		identificadores.clear();
		try {
		if (term instanceof Pred) {
			return (Predicate) term.accept(predConversor); 
		}
		else if (term instanceof Expr) {
			return (Expression) term.accept(exprConversor);
		}
		}catch (Exception e) /* Erro na passagem Circus2Bol*/{
			//e.printStackTrace();
		}
		return null;
	}

	public LinkedList<BIdentifier> getIdentificadores() {
		return identificadores;
	}
	
	public void insertIdentifier(BIdentifier idt){
		String str = idt.getValue();
		boolean jaInserido = false;
		for (BIdentifier id : identificadores){
			if (str.equals(id.getValue())){
				jaInserido = true;
			}
		}
		if (!jaInserido){
			identificadores.add(idt);
		}
	}

	
}
