package zb2smt.convertZ2B;

import java.util.LinkedList;
import java.util.List;
import java.util.Map;


import zb2smt.SMTString;
import zb2smt.bol.BIdentifier;
import zb2smt.bol.BInteger;
import zb2smt.bol.BooleanSet;
import zb2smt.bol.CartesianProduct;
import zb2smt.bol.ComprehensionSet;
import zb2smt.bol.Concatenate;
import zb2smt.bol.Division;
import zb2smt.bol.DomainRestriction;
import zb2smt.bol.DomainSubstraction;
import zb2smt.bol.EmptySet;
import zb2smt.bol.Exists;
import zb2smt.bol.Expression;
import zb2smt.bol.FinitePowerSet;
import zb2smt.bol.ISeq;
import zb2smt.bol.In;
import zb2smt.bol.IntegerSet;
import zb2smt.bol.Intersection;
import zb2smt.bol.Interval;
import zb2smt.bol.Lambda;
import zb2smt.bol.Modulo;
import zb2smt.bol.Not;
import zb2smt.bol.NotSetMemberShip;
import zb2smt.bol.Overriding;
import zb2smt.bol.PartialFunction;
import zb2smt.bol.PartialInjection;
import zb2smt.bol.PartialSurjection;
import zb2smt.bol.Plus;
import zb2smt.bol.Power;
import zb2smt.bol.PowerSet;
import zb2smt.bol.Predicate;
import zb2smt.bol.PredicateExpression;
import zb2smt.bol.Product;
import zb2smt.bol.RangeRestriction;
import zb2smt.bol.RangeSubstraction;
import zb2smt.bol.Relation;
import zb2smt.bol.Seq;
import zb2smt.bol.SetMinus;
import zb2smt.bol.Succ;
import zb2smt.bol.TotalBijection;
import zb2smt.bol.TotalFunction;
import zb2smt.bol.TotalInjection;
import zb2smt.bol.TotalSurjection;
import zb2smt.bol.Union;

import net.sourceforge.czt.circus.ast.CircusProcess;
import net.sourceforge.czt.circus.util.CircusString;
import net.sourceforge.czt.circus.util.CircusUtils;
import net.sourceforge.czt.z.ast.ApplExpr;
import net.sourceforge.czt.z.ast.Decl;
import net.sourceforge.czt.z.ast.Expr;
import net.sourceforge.czt.z.ast.InStroke;
import net.sourceforge.czt.z.ast.LambdaExpr;
import net.sourceforge.czt.z.ast.Name;
import net.sourceforge.czt.z.ast.NegExpr;
import net.sourceforge.czt.z.ast.NextStroke;
import net.sourceforge.czt.z.ast.NumExpr;
import net.sourceforge.czt.z.ast.OutStroke;
import net.sourceforge.czt.z.ast.PowerExpr;
import net.sourceforge.czt.z.ast.ProdExpr;
import net.sourceforge.czt.z.ast.RefExpr;
import net.sourceforge.czt.z.ast.SetCompExpr;
import net.sourceforge.czt.z.ast.SetExpr;
import net.sourceforge.czt.z.ast.Stroke;
import net.sourceforge.czt.z.ast.TupleExpr;
import net.sourceforge.czt.z.ast.VarDecl;
import net.sourceforge.czt.z.ast.ZDeclList;
import net.sourceforge.czt.z.ast.ZName;
import net.sourceforge.czt.z.ast.ZNameList;
import net.sourceforge.czt.z.ast.ZSchText;
import net.sourceforge.czt.z.util.ZString;
import net.sourceforge.czt.z.visitor.ApplExprVisitor;
import net.sourceforge.czt.z.visitor.LambdaExprVisitor;
import net.sourceforge.czt.z.visitor.NegExprVisitor;
import net.sourceforge.czt.z.visitor.NumExprVisitor;
import net.sourceforge.czt.z.visitor.PowerExprVisitor;
import net.sourceforge.czt.z.visitor.ProdExprVisitor;
import net.sourceforge.czt.z.visitor.RefExprVisitor;
import net.sourceforge.czt.z.visitor.SetCompExprVisitor;
import net.sourceforge.czt.z.visitor.SetExprVisitor;

/**
 * Classe utililizada para passar uma estrutura de Expressao de Circus para 
 * uma estrutura correspodente em B utilizando a AST da JBTools
 * @author alessandro87
 *
 */
public class ConvertCircus2BolExpr 
implements 
RefExprVisitor,
NumExprVisitor,
ApplExprVisitor,
SetExprVisitor,
ProdExprVisitor,
LambdaExprVisitor,
PowerExprVisitor,
SetCompExprVisitor
{

	private ConvertCircus2Bol conversor;
	
	
	public ConvertCircus2BolExpr(ConvertCircus2Bol conversor) {
		super();
		this.conversor = conversor;
	}

	public ConvertCircus2Bol getConversor() {
		return conversor;
	}

	public Object visitRefExpr(RefExpr term) {
		String str = ((ZName)term.getName()).getWord();
		
		/*
		 * RefExpr n�o dever� tratar operadores bin�ria  
		 */
		
		
		if (str.equals(ZString.ARITHMOS)) {
		}
		else if(str.equals(ZString.NAT)) {
			/* Utilizando Integer para imprimir alguns conjuntos predifinidos no smt_theory.txt*/
			IntegerSet expr = new IntegerSet();
			expr.setValue("NATURAL");
			return expr;
		}
		else if (str.startsWith(CircusUtils.DEFAULT_IMPLICIT_PROCESS_NAME_PREFIX)) {
			/* Nao tem em Bol*/
		}
		else if  (str.startsWith(ZString.XI)) {
		}
		else if (str.equals(ZString.EMPTYSET)) {
			EmptySet emptySet = new EmptySet();
			return emptySet;
		}
		else if (str.equals(CircusString.BOOLEAN)) {
			return new BooleanSet();
		}
		else if (str.equals(ZString.NAT + ZString.ARG_TOK + 1 )) {
			/* Utilizando Integer para imprimir alguns conjuntos predifinidos no smt_theory.txt*/
			IntegerSet expr = new IntegerSet();
			expr.setValue("NATURAL_1");
			return expr;
		}
		else if  (str.equals(ZString.NUM)) {
			/* Utilizando Integer para imprimir alguns conjuntos predifinidos no smt_theory.txt*/
			IntegerSet expr = new IntegerSet();
			expr.setValue("INTEGER");
			return expr;
		}
		else if(str.equals("#"+ZString.ARG_TOK)) {
			//  cardinal
			/* Nao tem nem em B e o Harvey ainda nao trata*/
		}
		else if(str.equals(ZString.FINSET + ZString.ARG_TOK)) {
			/* Utilizando Integer para imprimir alguns conjuntos predifinidos no smt_theory.txt*/
			IntegerSet expr = new IntegerSet();
			expr.setValue("FINSET");
			return expr;
		}
		else if(str.equals("seq" + ZString.ARG_TOK)) {
			Seq result = new Seq();
			Expression expr = null;
			if (term.getZExprList().size() != 0){
				expr = (Expression)term.getZExprList().get(0).accept(this);
				result.setExpression(expr);
			}
			return result;
		}
		else if (str.startsWith(ZString.DELTA)) {
		}
		else if(str.equals("iseq" + ZString.ARG_TOK)) {
			ISeq result = new ISeq();
			Expression expr = null;
			if (term.getZExprList().size() != 0){
				expr = (Expression)term.getZExprList().get(0).accept(this);
				result.setExpression(expr);
			}
			return result;
		}
		else if(str.equals("succ" + ZString.ARG_TOK)) {
			Succ result = new Succ();
			Expression expr = null;
			if (term.getZExprList().size() != 0){
				expr = (Expression)term.getZExprList().get(0).accept(this);
				result.setExpression(expr);
			}
			return result;
		}
		else if (str.equals("\\alpha")) {
			/* Nao existe em B nem em Harvey*/
		}
		else if (str.equals("DFV_Expr")) {
			/* Nao existe em B nem em Harvey*/
		}
		else if(str.equals(ZString.ARG_TOK + ZString.FUN + ZString.ARG_TOK)) {
			TotalFunction expr = new TotalFunction();
			Expression left = (Expression)term.getZExprList().get(0).accept(this);
			Expression right = (Expression)term.getZExprList().get(1).accept(this);
			expr.setLeft(left);
			expr.setLeft(right);
		}
		else if(str.equals(ZString.ARG_TOK + ZString.PFUN + ZString.ARG_TOK)) {
			PartialFunction expr = new PartialFunction();
			Expression left = (Expression)term.getZExprList().get(0).accept(this);
			Expression right = (Expression)term.getZExprList().get(1).accept(this);
			expr.setLeft(left);
			expr.setLeft(right);
		}
		else if(str.equals(ZString.ARG_TOK + ZString.CAP + ZString.ARG_TOK)) {
			Intersection expr = new Intersection();
			Expression left = (Expression)term.getZExprList().get(0).accept(this);
			Expression right = (Expression)term.getZExprList().get(1).accept(this);
			expr.setLeft(left);
			expr.setLeft(right);
		}
		else if(str.equals(ZString.ARG_TOK + ZString.PINJ + ZString.ARG_TOK)) {
			PartialInjection expr = new PartialInjection();
			Expression left = (Expression)term.getZExprList().get(0).accept(this);
			Expression right = (Expression)term.getZExprList().get(1).accept(this);
			expr.setLeft(left);
			expr.setLeft(right);
		}
		else if(str.equals(ZString.ARG_TOK + ZString.INJ + ZString.ARG_TOK)) {
			TotalInjection expr = new TotalInjection();
			Expression left = (Expression)term.getZExprList().get(0).accept(this);
			Expression right = (Expression)term.getZExprList().get(1).accept(this);
			expr.setLeft(left);
			expr.setLeft(right);
		}
		else if(str.equals(ZString.ARG_TOK + ZString.PSURJ + ZString.ARG_TOK)) {
			PartialSurjection expr = new PartialSurjection();
			Expression left = (Expression)term.getZExprList().get(0).accept(this);
			Expression right = (Expression)term.getZExprList().get(1).accept(this);
			expr.setLeft(left);
			expr.setLeft(right);
		}
		else if(str.equals(ZString.ARG_TOK + ZString.SURJ + ZString.ARG_TOK)) {
			TotalSurjection expr = new TotalSurjection();
			Expression left = (Expression)term.getZExprList().get(0).accept(this);
			Expression right = (Expression)term.getZExprList().get(1).accept(this);
			expr.setLeft(left);
			expr.setLeft(right);
		}
		else if(str.equals(ZString.ARG_TOK + ZString.BIJ + ZString.ARG_TOK)) {
			TotalBijection expr = new TotalBijection();
			Expression left = (Expression)term.getZExprList().get(0).accept(this);
			Expression right = (Expression)term.getZExprList().get(1).accept(this);
			expr.setLeft(left);
			expr.setLeft(right);
		}
		else if(str.equals(ZString.ARG_TOK + ZString.FFUN + ZString.ARG_TOK)) {
			//NAO TEM em B 
		}
		else if(str.equals(ZString.ARG_TOK + ZString.FINJ + ZString.ARG_TOK)) {
			//NAO TEM em B
		}
		else if(str.equals(ZString.ARG_TOK + ZString.REL + ZString.ARG_TOK)) {
			Relation expr = new Relation();
			Expression left = (Expression)term.getZExprList().get(0).accept(this);
			Expression right = (Expression)term.getZExprList().get(1).accept(this);
			expr.setLeft(left);
			expr.setLeft(right);
		}
		else if (str.equals(ZString.LANGLE + " " + ZString.COMMA + ZString.COMMA + " " + ZString.RANGLE)){
		}
		else if (str.equals(CircusUtils.DEFAULT_MAIN_ACTION_NAME)){
			/* Nao existe em B nem em Harvey*/
		}
		
		str = inserirStrokes(str, term.getZName());
		/* Caso Default: nome de identificador */
		BIdentifier identificador = new BIdentifier();
		identificador.setValue(str);
		
		/* Inserindo Identificador */
		this.conversor.insertIdentifier(identificador);
		
		return identificador;
	}


	public static String inserirStrokes(String str, ZName name) {
		if (!name.getZStrokeList().isEmpty()){
			for (Stroke stroke : name.getZStrokeList()){
				if (stroke instanceof InStroke){
					str+= SMTString.INSTROKE;
				}
				else if (stroke instanceof OutStroke){
					str+= SMTString.OUTSTROKE;
				}
				else if (stroke instanceof NextStroke){
					str+= SMTString.NEXTSTROKE;
				}
			}
		}
		return str;
	}

	public Object visitNumExpr(NumExpr term) {
		BInteger inteiro = new BInteger();
		inteiro.setValue(term.getValue().toString());
		return inteiro;
	}
	

	public Object visitApplExpr(ApplExpr term) {
		if(term.getMixfix()) {
			
			if (term.getLeftExpr() instanceof RefExpr){
				ZName refName = ((RefExpr)term.getLeftExpr()).getZName();
				if(refName.getWord().equals(ZString.ARG_TOK + ZString.CUP + ZString.ARG_TOK)) {
					Union expr = new Union();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					expr.setLeft(left);
					expr.setRight(right);
					
					return expr;
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.CAP + ZString.ARG_TOK)) {
					Intersection expr = new Intersection();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					expr.setLeft(left);
					expr.setRight(right);
					
					return expr;
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.SETMINUS + ZString.ARG_TOK)) {
					SetMinus expr = new SetMinus();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					expr.setLeft(left);
					expr.setRight(right);
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.SYMDIFF + ZString.ARG_TOK)) {
					/* TODO Nao tem na gramatica Bol mas tem em harvey*/
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.PLUS + ZString.ARG_TOK)) {
					Plus soma = new Plus();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					soma.setLeft(left);
					soma.setRight(right);
					
					return soma;
				
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.MAPSTO + ZString.ARG_TOK)) {
					/* Nao tem na gramatica Bol*/
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.REL + ZString.ARG_TOK)) {
					Relation rel = new Relation();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					rel.setLeft(left);
					rel.setRight(right);
					
					return rel;
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.COMP + ZString.ARG_TOK)) {
					/* Nao tem na gramatica Bol*/
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.CIRC + ZString.ARG_TOK)) {
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.DRES + ZString.ARG_TOK)) {
					DomainRestriction expr = new DomainRestriction();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					expr.setLeft(left);
					expr.setRight(right);
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.RRES + ZString.ARG_TOK)) {
					RangeRestriction expr = new RangeRestriction();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					expr.setLeft(left);
					expr.setRight(right);
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.NDRES + ZString.ARG_TOK)) {
					DomainSubstraction expr = new DomainSubstraction();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					expr.setLeft(left);
					expr.setRight(right);
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.NRRES + ZString.ARG_TOK)) {
					RangeSubstraction expr = new RangeSubstraction();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					expr.setLeft(left);
					expr.setRight(right);
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.OPLUS + ZString.ARG_TOK)) {
					Overriding expr = new Overriding();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					expr.setLeft(left);
					expr.setRight(right);
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.MINUS + ZString.ARG_TOK)) {
					zb2smt.bol.Minus expr = new zb2smt.bol.Minus();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					expr.setLeft(left);
					expr.setRight(right);
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.MULT + ZString.ARG_TOK)) {
					Product prod = new Product();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					prod.setLeft(left);
					prod.setRight(right);
					return prod;
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + "mod" + ZString.ARG_TOK)) {
					
					Modulo mod = new Modulo();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					mod.setLeft(left);
					mod.setRight(right);
					
					return mod;
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + "div" + ZString.ARG_TOK)) {
					
					Division div = new Division();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					div.setLeft(left);
					div.setRight(right);
					return div;
					
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ".." + ZString.ARG_TOK)) {
					Interval inter = new Interval();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					inter.setLeft(left);
					inter.setRight(right);
					return inter;
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.CAT + ZString.ARG_TOK)) {
					Concatenate expr = new Concatenate();
					TupleExpr tupla = (TupleExpr)term.getRightExpr();
					Expression left = (Expression)tupla.getZExprList().get(0).accept(this);
					Expression right = (Expression)tupla.getZExprList().get(1).accept(this);
					expr.setLeft(left);
					expr.setRight(right);
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.EXTRACT + ZString.ARG_TOK)) {
					// nao tem no BOL;
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.FILTER + ZString.ARG_TOK)) {
					// nao tem no BOL;
				}
				else if(refName.getWord().equals(ZString.ARG_TOK + ZString.NOTMEM + ZString.ARG_TOK)) {
					
					NotSetMemberShip result = new NotSetMemberShip();
					Expr left = term.getLeftExpr();
					Expr right = term.getRightExpr();
					//The Expression
					Expression leftExpr = (Expression)left.accept(conversor.getExprConversor());
					//The Set
					Expression rightExpr = (Expression)right.accept(conversor.getExprConversor());
					Expression[] exprs = new Expression[1];
					exprs[0] = leftExpr;
					
					result.setSet(rightExpr);
					result.setExpressions(exprs);

					return result;
				}
			}
			
		}
		return null;
	}

	public Object visitSetExpr(SetExpr term) {
		Expression[] result = new Expression[term.getZExprList().size()];
		int index= 0;
		for (Expr expr : term.getZExprList()){
			Expression visitado = (Expression)expr.accept(this);
			result[index++] = visitado; 
		}
		return result;
	}

	public Object visitProdExpr(ProdExpr term) {
		CartesianProduct result = new CartesianProduct();
		Expression left = (Expression)term.getZExprList().get(0).accept(this);
		Expression right = (Expression)term.getZExprList().get(0).accept(this);
		
		result.setLeft(left);
		result.setRight(right);
		
		return result;
	}

	public Object visitLambdaExpr(LambdaExpr term) {
		
		Lambda result = new Lambda();
		ZSchText schemaText = term.getZSchText();
		/*
		 * Pegando o predicado
		 */
		Predicate pred = (Predicate)term.getZSchText().getPred().accept(this);
		ZDeclList idts = schemaText.getZDeclList();
		
		LinkedList<BIdentifier> lista = new LinkedList<BIdentifier>();
		
		/*
		 *Pegando as variaveis/BIdentifiers 
		 */
		for (Decl dec : idts){
			VarDecl var = (VarDecl)dec;	
			ZNameList nameList = var.getZNameList();
			for (Name name : nameList){
				String word = ((ZName)name).getWord();
				word = ConvertCircus2BolExpr.inserirStrokes(word, (ZName)name);
				/* Caso Default: nome de identificador */
				BIdentifier identificador = new BIdentifier();
				identificador.setValue(word);
				
				lista.add(identificador);
				/* Inserindo Identificador */
				this.conversor.insertIdentifier(identificador);
			}
		}
		
		result.setIdentifiers((BIdentifier[])lista.toArray());
		result.setPredicate(pred);
		
		return result;
	}

	public Object visitPowerExpr(PowerExpr term) {
		PowerSet result = new PowerSet();
		Expression expr = (Expression)term.getExpr().accept(this);
		Expression[] exprs = new Expression[1];
		exprs[0] = expr;
		result.setSets(exprs);
		
		return result;
		
	}

	public Object visitSetCompExpr(SetCompExpr term) {
		ComprehensionSet result = new ComprehensionSet();
		ZSchText schemaText = term.getZSchText();
		/*
		 * Pegando o predicado
		 */
		Predicate pred = new PredicateExpression((Expression)term.getExpr().accept(this));
		ZDeclList idts = schemaText.getZDeclList();
		
		LinkedList<BIdentifier> lista = new LinkedList<BIdentifier>();
		
		/*
		 *Pegando as variaveis/BIdentifiers 
		 */
		for (Decl dec : idts){
			VarDecl var = (VarDecl)dec;	
			ZNameList nameList = var.getZNameList();
			for (Name name : nameList){
				String word = ((ZName)name).getWord();
				word = ConvertCircus2BolExpr.inserirStrokes(word, (ZName)name);
				/* Caso Default: nome de identificador */
				BIdentifier identificador = new BIdentifier();
				identificador.setValue(word);
				
				lista.add(identificador);
				/* Inserindo Identificador */
				this.conversor.insertIdentifier(identificador);
			}
		}
		
		result.setIdentifiers((BIdentifier[])lista.toArray());
		result.setPredicate(pred);
		
		return result;
	}

	

}
