package zb2smt.convertZ2B;


import java.util.LinkedList;
import java.util.List;

import javax.swing.JOptionPane;

import com.sun.xml.internal.bind.marshaller.NioEscapeHandler;

import zb2smt.bol.And;
import zb2smt.bol.BBoolean;
import zb2smt.bol.BIdentifier;
import zb2smt.bol.Equal;
import zb2smt.bol.Equivalence;
import zb2smt.bol.Exists;
import zb2smt.bol.Expression;
import zb2smt.bol.ForAll;
import zb2smt.bol.GreatherThan;
import zb2smt.bol.GreatherThanOrEqual;
import zb2smt.bol.Implication;
import zb2smt.bol.In;
import zb2smt.bol.LessThan;
import zb2smt.bol.LessThanOrEqual;
import zb2smt.bol.Not;
import zb2smt.bol.NotEqual;
import zb2smt.bol.NotSetMemberShip;
import zb2smt.bol.Or;
import zb2smt.bol.Predicate;
import zb2smt.bol.PredicateExpression;
import zb2smt.bol.SetPredicate;
import zb2smt.bol.StrictSubset;
import zb2smt.bol.Subset;

import net.sourceforge.czt.base.ast.ListTerm;
import net.sourceforge.czt.base.ast.Term;
import net.sourceforge.czt.base.visitor.TermVisitor;
import net.sourceforge.czt.oz.ast.PredExpr;
import net.sourceforge.czt.oz.visitor.PredExprVisitor;
import net.sourceforge.czt.util.Visitor;
import net.sourceforge.czt.z.ast.AndPred;
import net.sourceforge.czt.z.ast.Decl;
import net.sourceforge.czt.z.ast.Exists1Pred;
import net.sourceforge.czt.z.ast.ExistsPred;
import net.sourceforge.czt.z.ast.Expr;
import net.sourceforge.czt.z.ast.ExprPred;
import net.sourceforge.czt.z.ast.FalsePred;
import net.sourceforge.czt.z.ast.ForallPred;
import net.sourceforge.czt.z.ast.IffPred;
import net.sourceforge.czt.z.ast.ImpliesPred;
import net.sourceforge.czt.z.ast.MemPred;
import net.sourceforge.czt.z.ast.Name;
import net.sourceforge.czt.z.ast.NegPred;
import net.sourceforge.czt.z.ast.OrPred;
import net.sourceforge.czt.z.ast.Pred;
import net.sourceforge.czt.z.ast.Pred2;
import net.sourceforge.czt.z.ast.RefExpr;
import net.sourceforge.czt.z.ast.TruePred;
import net.sourceforge.czt.z.ast.TupleExpr;
import net.sourceforge.czt.z.ast.VarDecl;
import net.sourceforge.czt.z.ast.ZDeclList;
import net.sourceforge.czt.z.ast.ZName;
import net.sourceforge.czt.z.ast.ZNameList;
import net.sourceforge.czt.z.ast.ZSchText;
import net.sourceforge.czt.z.util.ZString;
import net.sourceforge.czt.z.visitor.AndPredVisitor;
import net.sourceforge.czt.z.visitor.Exists1PredVisitor;
import net.sourceforge.czt.z.visitor.ExistsPredVisitor;
import net.sourceforge.czt.z.visitor.ExprPredVisitor;
import net.sourceforge.czt.z.visitor.FalsePredVisitor;
import net.sourceforge.czt.z.visitor.ForallPredVisitor;
import net.sourceforge.czt.z.visitor.IffPredVisitor;
import net.sourceforge.czt.z.visitor.ImpliesPredVisitor;
import net.sourceforge.czt.z.visitor.MemPredVisitor;
import net.sourceforge.czt.z.visitor.NegPredVisitor;
import net.sourceforge.czt.z.visitor.OrPredVisitor;
import net.sourceforge.czt.z.visitor.Pred2Visitor;
import net.sourceforge.czt.z.visitor.TruePredVisitor;


/**
 * Classe utililizada para passar uma estrutura de Circus para 
 * uma estrutura correspodente em B utilizando a AST da JBTools
 * @author alessandro87
 *
 */
public class ConvertCircus2BolPred
implements
AndPredVisitor,
OrPredVisitor,
IffPredVisitor,
ImpliesPredVisitor,
FalsePredVisitor,
TruePredVisitor,
MemPredVisitor,
ExistsPredVisitor,
Exists1PredVisitor,
ForallPredVisitor,
ExprPredVisitor,
NegPredVisitor
{

	static ConvertCircus2Bol conversor;

	public ConvertCircus2BolPred(ConvertCircus2Bol conversor) {
		this.conversor = conversor;
	}

	/**
	 * Funcao auxiliar que e utilizada na implementacao do visitor
	 * de termos que extendem Pred2 como AndPred, OrPred, etc.
	 * @param term
	 * @return
	 */
	public Predicate[] getPredicatesfromPred2 (Pred2 term) {

		ListTerm<Pred> preds = term.getPred();
		int index = 0;
		int size = preds.size();

		Predicate[] predicates = new Predicate[size];
		for (Pred pr : preds){
			Predicate predicate = (Predicate)pr.accept(this);
			predicates[index++] = predicate;
		}
		return predicates;
	}


	/**
	 * Pega uma tupla e retorna as expressos q represantam os 
	 * elementos do lado esquerdo e do lado direito de algum
	 * MemPred
	 * @param expr
	 * @return
	 */
	private Expression[] getExprsFromTuple(TupleExpr expr) {
		Expression[] result = new Expression[2];
		result[0] = (Expression) expr.getZExprList().get(0).accept(conversor.getExprConversor());
		result[1] = (Expression) expr.getZExprList().get(1).accept(conversor.getExprConversor());
		return result;
	}


	/**
	 * Utilizado no metodo de MemPred, visa pegar a tupla de expressoes,
	 * sendo o segundo elemento o conjunto. Utilizado em SetPredicates 
	 * : NotMem, Subset...
s	 * @param term
	 * @return
	 */
	private Expression getExprSetFromMemPred(MemPred term) {

		TupleExpr tupla = (TupleExpr)term.getLeftExpr();
		Expr set = tupla.getZExprList().get(1);
		Expression setB = (Expression)set.accept(conversor.getExprConversor());

		return setB;
	}

	/**
	 * Utilizado no metodo de MemPred, visa pegar a tupla de expressoes,
	 * sendo os elementos do lado esquerdo (x notin Z, ira pegar x) .
	 *  Utilizado em SetPredicates: NotMem, Subset... 
s	 * @param term
	 * @return
	 */
	private Expression[] getExprsFromMemPred(MemPred term) {

		TupleExpr tupla = (TupleExpr)term.getLeftExpr();
		Expr expression = tupla.getZExprList().get(0);
		Expression expressionB = (Expression) expression.accept(conversor.getExprConversor());
		Expression[] exprs = new Expression[1];
		exprs[0] = expressionB;

		return exprs;
	}

	public ConvertCircus2Bol getConversor() {
		return conversor;
	}


	public Object visitAndPred(AndPred term) {
		conversor.getPercurso().append("AndPred" + "\n");
		And result = new And();
		Predicate[] predicates = getPredicatesfromPred2(term);
		result.setPredicates(predicates);
		return result;
	}


	public Object visitOrPred(OrPred term) {
		conversor.getPercurso().append("OrPred" + "\n");
		Or result = new Or();

		Predicate[] predicates = getPredicatesfromPred2(term);
		result.setPredicates(predicates);
		return result;	
	}


	public Object visitIffPred(IffPred term) {
		conversor.getPercurso().append("IffPred" + "\n");
		Equivalence result = new Equivalence();

		Predicate left = (Predicate)term.getLeftPred().accept(this);
		Predicate right = (Predicate)term.getRightPred().accept(this);

		result.setLeft(left);
		result.setRight(right);

		return result;
	}


	public Object visitImpliesPred(ImpliesPred term) {
		conversor.getPercurso().append("ImpliesPred" + "\n");
		Implication result = new Implication();

		Predicate left = (Predicate)term.getLeftPred().accept(this);
		Predicate right = (Predicate)term.getRightPred().accept(this);

		result.setLeft(left);
		result.setRight(right);

		return result;
	}



	public Object visitFalsePred(FalsePred term) {
		BBoolean bol = new BBoolean();
		bol.setFields("false");
		PredicateExpression pred = new PredicateExpression(bol);
		return pred;
	}


	public Object visitTruePred(TruePred term) {
		BBoolean bol = new BBoolean();
		bol.setFields("true");
		PredicateExpression pred = new PredicateExpression(bol);
		return pred;
	}

	/**
	 * Implementa elementos gramaticais como In, NotIn, Subset, etc.
	 */
	public Object visitMemPred(MemPred term) {
		conversor.getPercurso().append("MemPred" + "\n");

		/* Membership predicate. In this case, Mixfix=false, the first (left) 
		 * expression is the element, and the second (right) expression is 
		 * the set. For example, "n \in S" has left="n" and right="S".
		 */
		if (!term.getMixfix()) {
			In result = new In();
			Expr left = term.getLeftExpr();
			Expr right = term.getRightExpr();
			//The Expression
			Expression leftExpr = (Expression)left.accept(conversor.getExprConversor());
			//The Set
			Expression rightExpr = (Expression)right.accept(conversor.getExprConversor());
			Expression[] exprs = new Expression[1];
			exprs[0] = leftExpr;
			
			result.setSet(rightExpr);
			result.setExpressions(exprs);

			return result;
		}
		/*  Equality. In this case, Mixfix=true, the first (left) expression
		 *  is the left-hand side of the equality, and the second (right) 
		 *  expression is a singleton set containing the right-hand side of
		 *   the equality. For example: "n = m" has left="n" and right="{m}"
		 */
		else {
			if (term.getRightExpr() instanceof RefExpr){
				String name = ((RefExpr)term.getRightExpr()).getZName().getWord();
				/* Caso : NotSetMemberShip
				 * Exemplo A \notin B tem: left (A,B) e right (_ \notin_)
				 * Nesse caso temos que pegar o primeiro da elemento como expressao
				 * e o segundo elemento da esquerda como set
				 * */

				if (name.equals(ZString.ARG_TOK + ZString.NOTMEM + ZString.ARG_TOK)){
					SetPredicate result;
					result = new NotSetMemberShip();

					Expression[] exprs = getExprsFromMemPred(term);
					Expression setB = getExprSetFromMemPred(term);

					result.setSet(setB);
					result.setExpressions(exprs);
					return result;
				}
				else if(name.equals(ZString.ARG_TOK + ZString.SUBSET + ZString.ARG_TOK)){
					SetPredicate result;
					result = new StrictSubset();

					Expression[] exprs = getExprsFromMemPred(term);
					Expression setB = getExprSetFromMemPred(term);

					result.setSet(setB);
					result.setExpressions(exprs);
					return result;
				}
				else if(name.equals(ZString.ARG_TOK + ZString.SUBSETEQ + ZString.ARG_TOK)){
					SetPredicate result;
					result = new Subset();

					Expression[] exprs = getExprsFromMemPred(term);
					Expression setB = getExprSetFromMemPred(term);

					result.setSet(setB);
					result.setExpressions(exprs);
					return result;
				}
				else if(name.equals(ZString.ARG_TOK + ZString.NEQ + ZString.ARG_TOK)){

					NotEqual result = new NotEqual();

					Expression[] exprs = getExprsFromTuple((TupleExpr)term.getLeftExpr());

					result.setFields(exprs);
					return result;
				}
				else if(name.equals(ZString.ARG_TOK + ZString.LEQ + ZString.ARG_TOK)){

					LessThanOrEqual result = new LessThanOrEqual();
					Expression[] exprs = getExprsFromTuple((TupleExpr)term.getLeftExpr());

					result.setFields(exprs);
					return result;
				}
				else if(name.equals(ZString.ARG_TOK + ZString.GEQ + ZString.ARG_TOK)){

					GreatherThanOrEqual result = new GreatherThanOrEqual();
					Expression[] exprs = getExprsFromTuple((TupleExpr)term.getLeftExpr());

					result.setFields(exprs);
					return result;
				}
				else if(name.equals(ZString.ARG_TOK + ZString.LESS + ZString.ARG_TOK)){

					LessThan result = new LessThan();
					Expression[] exprs = getExprsFromTuple((TupleExpr)term.getLeftExpr());

					result.setFields(exprs);
					return result;
				}
				else if(name.equals(ZString.ARG_TOK + ZString.GREATER + ZString.ARG_TOK)){

					GreatherThan result = new GreatherThan();
					Expression[] exprs = getExprsFromTuple((TupleExpr)term.getLeftExpr());

					result.setFields(exprs);				
					return result;
				}
				/* EQUALS*/
				else{
					
					Equal result = new Equal();
					Expression left = (Expression) term.getLeftExpr().accept(conversor.getExprConversor());
					Expression right = ((Expression[]) term.getRightExpr().accept(conversor.getExprConversor()))[0];
					result.setLeft(left);
					result.setRight(right);
					return result;

				}
				
			}
			/* EQUALS*/
			else{
				
				
				Equal result = new Equal();
				Expression left = (Expression) term.getLeftExpr().accept(conversor.getExprConversor());
				Expression right = ((Expression[]) term.getRightExpr().accept(conversor.getExprConversor()))[0];
				result.setLeft(left);
				result.setRight(right);
				return result;

			}

		}
	}


	public Object visitExistsPred(ExistsPred term) {
		Exists result = new Exists();
		ZSchText schemaText = term.getZSchText();
		/*
		 * Pegando o predicado
		 */
		Predicate pred = (Predicate)term.getPred().accept(this);
		ZDeclList idts = schemaText.getZDeclList();
		
		LinkedList<BIdentifier> lista = new LinkedList<BIdentifier>();
		
		/*
		 *Pegando as variaveis/BIdentifiers 
		 */
		for (Decl dec : idts){
			VarDecl var = (VarDecl)dec;	
			ZNameList nameList = var.getZNameList();
			for (Name name : nameList){
				String word = ((ZName)name).getWord();
				word = ConvertCircus2BolExpr.inserirStrokes(word, (ZName)name);
				/* Caso Default: nome de identificador */
				BIdentifier identificador = new BIdentifier();
				identificador.setValue(word);
				
				lista.add(identificador);
				/* Inserindo Identificador */
				this.conversor.insertIdentifier(identificador);
			}
		}
		
		result.setIdentifiers((BIdentifier[])lista.toArray());
		result.setPredicate(pred);
		
		return result;
	}


	public Object visitExists1Pred(Exists1Pred term) {
		// TODO bol nao tem!
		return null;
	}


	public Object visitForallPred(ForallPred term) {
		ForAll result = new ForAll();
		ZSchText schemaText = term.getZSchText();
		/*
		 * Pegando o predicado
		 */
		Predicate pred = (Predicate)term.getPred().accept(this);
		ZDeclList idts = schemaText.getZDeclList();
		
		LinkedList<BIdentifier> lista = new LinkedList<BIdentifier>();
		
		/*
		 *Pegando as variaveis/BIdentifiers 
		 */
		for (Decl dec : idts){
			VarDecl var = (VarDecl)dec;	
			ZNameList nameList = var.getZNameList();
			for (Name name : nameList){
				String word = ((ZName)name).getWord();
				word = ConvertCircus2BolExpr.inserirStrokes(word, (ZName)name);
				/* Caso Default: nome de identificador */
				BIdentifier identificador = new BIdentifier();
				identificador.setValue(word);
				
				lista.add(identificador);
				/* Inserindo Identificador */
				this.conversor.insertIdentifier(identificador);
			}
		}
		
		result.setIdentifiers((BIdentifier[])lista.toArray());
		result.setImplication((Implication)pred);
		
		return result;
	}

	public Object visitNegPred(NegPred term) {
		conversor.getPercurso().append("NegPred" + "\n");
		Predicate pred = (Predicate)term.getPred().accept(this);
		Not result = new Not();
		result.setPredicate(pred);
		return result;
	}

	public Object visitExprPred(ExprPred term) {
		Expression expr  = (Expression)term.getExpr().accept(conversor.getExprConversor());
		PredicateExpression pred = new PredicateExpression(expr);
		return pred;
	}





}
